<?php
defined ('_JEXEC') or die('Restricted access');

use Baikalsr\Lib\Tools;
use Joomla\CMS\Form\Form;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;
if(!class_exists('VmConfig')) {
	require(JPATH_ADMINISTRATOR . '/components/com_virtuemart/helpers/config.php');
}
        
if (!class_exists('VirtueMartModelOrders')) {
	require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
}	

if(!class_exists('vmPSPlugin')) {
	require(VMPATH_PLUGINLIBS . DS . 'vmpsplugin.php');
}


if (!class_exists ('Tools')) {
	require(VMPATH_PLUGINS . DS . 'vmshipment' . DS . 'baikalsr' . DS . 'lib' . DS . 'tools.php');
}

class plgVmShipmentBaikalsr extends vmPSPlugin {

	private $baikalsrTools;
	/**
	 * @param object $subject
	 * @param array  $config
	 */
	function __construct (& $subject, $config) {

		parent::__construct ($subject, $config);
		$this->_tablepkey = 'id';
		$this->_tableId = 'id';
		$this->tableFields = array_keys ($this->getTableSQLFields ());
		$varsToPush = $this->getVarsToPush ();
		$this->addVarsToPushCore($varsToPush,0);
		$this->_loggable = TRUE;
		
		$this->setConfigParameterable ($this->_configTableFieldName, $varsToPush);
		$this->setConvertable(array('min_amount','max_amount','additional_cost'));

		$this->baikalsrTools = new Tools();
	}
	
	/**
	 * Создает таблицу для плагина, структура которой определена методом getTableSQLFields().
	 * Или обновляет таблицу, если она существует.
	 * Вызывается при создании или обновлении способа доставки.
	 *
	 */
	function plgVmOnStoreInstallShipmentPluginTable ($jplugin_id) {
		if ($jplugin_id != $this->_jid) {
			return FALSE;
		}
		$this->createUserField();
		
		return parent::onStoreInstallPluginTable ($jplugin_id);
	}
	
	/**
	 * Старый метод, который создает таблицу для плагина, структура которой определена методом getTableSQLFields().
	 * Или обновляет таблицу, если она существует.
	 * Вызывается при создании или обновлении способа доставки.
	 *
	 */
	function OnStoreInstallPluginTable () {

		if ($jplugin_id != $this->_jid) {
			return FALSE;
		}
		$this->createUserField();
		
		return parent::onStoreInstallPluginTable ($jplugin_id);

	}
	
	/**
	 * Автоматически создает пользовательское поле для выбора города из списка по классификатору адресов.
	 * При условии что плагин Байкал-Сервис для пользовательских полей (vmuserfield) установлен.
	 *
	 */	
	private function createUserField() {
		$db = JFactory::getDBO();
		$q = 'SELECT `extension_id` FROM `#__extensions` WHERE `folder` = "vmuserfield" and `state`="0" AND `element` = "'.$this->_name.'"';
		$db->setQuery($q);
		$extension_id = $db->loadResult();
		if (empty($extension_id)) {
			$app = JFactory::getApplication();
			$app->enqueueMessage(vmText::_('VMSHIPMENT_BAIKAL_NO_PLUGIN_INSTALLED'));
			return;
		}
		// активаций плагина
		$q="UPDATE  `#__extensions` SET  `enabled` =  '1' WHERE NOT `enabled` =  '1' AND `extension_id` =".$extension_id;
		$db->setQuery($q);
		$db->execute();

		// Создает пользовательское поле для выбора города из списка, если она еще не существует.
		$q = 'SELECT `virtuemart_userfield_id` FROM `#__virtuemart_userfields` WHERE `userfield_jplugin_id` = ' . $extension_id;
		$db->setQuery($q);
		$virtuemart_userfield_id = $db->loadResult();
		if (empty($virtuemart_userfield_id)) {
			//$app = JFactory::getApplication();

			$userFieldsModel = VmModel::getModel('UserFields');
			$data['virtuemart_userfield_id'] = 0;
			$data['userfield_jplugin_id'] = $extension_id;		
			$data['type'] = 'plugin'.$this->_name;
			$data['name'] = 'baikalsr_city';
			$data['title'] = vmText::_('VMSHIPMENT_BAIKAL_CITY_CODE') . ' ' . '(GUID)';
			$data['published'] = 1;
			$data['required'] = 0;
			$data['account'] = 1;
			$data['shipment'] = 1;
			$data['registration'] = 0;
			$data['vNames'] = array();
			$data['vValues'] = array();
			$ret = $userFieldsModel->store($data);

			if (!$ret) {
				vmError(vmText::_('VMSHIPMENT_BAIKAL_CREATE_USERFIELD_FAILED') . " " . $data['name'] . " " . $ret);
			} else {
				vmInfo(vmText::_('VMSHIPMENT_BAIKAL_CREATE_USERFIELD_OK') . " " . $data['name']);
			}
		}

	}

	/**
	 * Поля для хранения информации по отправленным заявкам в ТК "Байкал-сервис" 
	 * @return array
	 */
	function getTableSQLFields () {

		$SQLfields = array(
			'id'                           => 'int(1) UNSIGNED NOT NULL AUTO_INCREMENT',
			'virtuemart_order_id'          => 'int(11) UNSIGNED',
			'order_number'                 => 'char(32)',
			'virtuemart_shipmentmethod_id' => 'mediumint(1) UNSIGNED',
			'shipment_name'                => 'varchar(5000)',
			'shipment_data'                => 'text NULL',
			'shipment_id'                  => 'int(11) UNSIGNED NULL',
			'tracking_number'              => 'varchar(36) NULL',
			'status_name'                  => 'varchar(250) DEFAULT \'' . vmText::_ ('VMSHIPMENT_BAIKAL_STATUS_0') . '\'',
			'order_weight'                 => 'decimal(10,4)',
			'shipment_weight_unit'         => 'char(3) DEFAULT \'KG\'',
			'order_volume'                 => 'decimal(10,4)',
			'shipment_lwh_unit'            => 'char(3) DEFAULT \'M\'',
			'shipment_cost'                => 'decimal(10,2)',
			'shipment_actual_cost'         => 'decimal(10,2)',
			'shipment_add_cost'            => 'decimal(10,2)',
			'tax_id'                       => 'smallint(1)'
		);
		return $SQLfields;
	}
	

	/**
	 * Этот метод запускается при отображении сведений о заказе во внешнем интерфейсе.
	 * Он отображает данные, относящиеся к конкретной отгрузке.
	 *
	 * @param integer $virtuemart_order_id Идентификатор заказа
	 * @param integer $virtuemart_shipmentmethod_id Идентификатор выбранного способа доставки
	 * @param string  $shipment_name Наименование способа доставки
	 * @return смешанный Null для отправлений, которые не активны, text (HTML) в противном случае
	 */
	public function plgVmOnShowOrderFEShipment ($virtuemart_order_id, $virtuemart_shipmentmethod_id, &$shipment_name) {

		//$this->onShowOrderFE ($virtuemart_order_id, $virtuemart_shipmentmethod_id, $shipment_name);
	}

	/**
	 * plgVmDisplayListFE
	 * Это событие запускается при отображении подключаемых способов доставки в корзине
	 *
	 * @param object  $cart Объект корзины
	 * @param integer $selected Идентификатор выбранного способа
	 * @return boolean TRUE при успешном выполнении, FALSE при сбоях, NULL, когда этот плагин не был выбран.
	 * При ошибках для установки сообщения необходимо использовать JError::raiseWarning (или JError::RaiseError).
	 *
	 */
	public function plgVmDisplayListFEShipment (VirtueMartCart $cart, $selected, &$htmlIn) {

		if ($this->getPluginMethods ($cart->vendorId) === 0) {
			if (empty($this->_name)) {
				vmAdminInfo ('displayListFE cartVendorId=' . $cart->vendorId);
				$app = JFactory::getApplication ();
				$app->enqueueMessage (vmText::_ ('COM_VIRTUEMART_CART_NO_' . strtoupper ($this->_psType)));
				return FALSE;
			} else {
				return FALSE;
			}
		}

		$mname = $this->_psType . '_name';
		$idN = 'virtuemart_'.$this->_psType.'method_id';

		$ret = FALSE;

		foreach ($this->methods as $method) {
			if(!isset($htmlIn[$this->_psType][$method->{$idN}])) {
				if ($this->checkConditions ($cart, $method, $cart->cartPrices)) {

					// the price must not be overwritten directly in the cart
					$prices = $cart->cartPrices;
					$methodSalesPrice = $this->setCartPrices ($cart, $prices ,$method);

					//This makes trouble, because $method->$mname is used in  renderPluginName to render the Name, so it must not be called twice!
					$method->{$mname} = $this->renderPluginName ($method);

					$htmlIn[$this->_psType][$method->{$idN}] = $this->getPluginHtml ($method, $selected, $methodSalesPrice);
					
					//Разрешен ли вывод срока доставки в настройках метода доставки
					if($method->show_term){
						$htmlIn[$this->_psType][$method->{$idN}] .= $this->_getTermsHtml ($cart, $method);
					}
					
					$ret = TRUE;
				}
			} else {
				$ret = TRUE;
			}
		}

		return $ret;
	}
	
	/**
	 * Вывод срока доставки из кеша при отображении метода доставки
	 *
	 * @param object  $cart Объект корзины
	 * @param integer $method Идентификатор выбранного способа
	 * @return string TRUE при успешном выполнении, FALSE при сбоях, NULL, когда этот плагин не был выбран.
	 *
	 */	
	protected function _getTermsHtml (VirtueMartCart $cart, $method) {
		$html = '';
		$address = $this->_getAddressFromCart($cart);
		$destination = $this->_getLocationWithGUIDFromAddress($address);

		$total_weight = $this->_getItemsWeight($cart->products, $method);		
		$total_dimensions = $this->_getItemsDimensions ($cart->products, $method);
		$total_price = $this->getCartAmount($cart->cartPrices, true); //$cart_prices['salesPrice'];
		
		jimport('joomla.cache.cache');
		$cache_id = preg_replace('/\s|\&|\.|\,|\-|\+/', '', 'baikalsr_calc-' . $method->departure_guid . $method->departure_from_address . $destination['guid'] . $total_weight . $total_dimensions["volume"] . $total_price . $method->packing_id);
		$conf = \JFactory::getConfig();
		$options = array(
			'defaultgroup' 	=> 'plg_baikalsr_shipping',
			'cachebase' 	=> $conf->get('cache_path', JPATH_CACHE),
			'lifetime' 		=> 10*60,
			'language' 		=> $conf->get('language', 'en-GB'),
			'storage' 		=> $conf->get('cache_handler', ''),
			'caching' 		=> true,
		);
		$cache = new \JCache($options);

		// Проверим есть ли кешированное значение
		if ($cache->contains($cache_id)){
			
			$calcResult = unserialize($cache->get($cache_id));
			if(isset($calcResult["transit"]["int"]) && isset($calcResult["transit"]["day"])){
				$term = (int) $calcResult["transit"]["int"];
				if($method->destination_to_address){
					$html = $calcResult["transit"]["int"] . ' ' . $calcResult["transit"]["day"];
				}else{
					if((int)$calcResult["transit"]["int"]>1)
						$calcResult["transit"]["int"] = (int)$calcResult["transit"]["int"] - 1;
					$html = $calcResult["transit"]["int"] . ' ' . $calcResult["transit"]["day"];
				}
			}
			$t = vmText::_( 'VMSHIPMENT_BAIKAL_TERM_LBL' );
			if(!empty($html)) 
				$html = '<span class="'.$this->_psType.'_terms" style="display: block">'.$t.': '.$html."</span>";
		}

		return $html;

	}	
	
	/**
	 * Триггер для динамического отображения html-кода на странице сведений о товаре.
	 *
	 * @param $product Объект товара
	 * @param $productDisplayShipments
	 *
	 */
	function plgVmOnProductDisplayShipment($product, &$productDisplayShipments){

		if ($this->getPluginMethods($product->virtuemart_vendor_id) === 0) {

			return FALSE;
		}

		$html = array();

		$currency = CurrencyDisplay::getInstance();
		
		$mname = $this->_psType . '_name';
		
		foreach ($this->methods as $this->_currentMethod) {
	
			if($this->_currentMethod->show_on_pdetails){
				if(!isset($cart)){
					$cart = VirtueMartCart::getCart();
					$cart->products['single'] = $product;
					$cart->_productAdded = true;
					$cart->prepareCartData();
				}
				if($this->checkConditions($cart,$this->_currentMethod,$product->prices)){

					$product->prices['shipmentPrice'] = $this->getCosts($cart, $this->_currentMethod, $product->prices);				
					if(isset($product->prices['VatTax']) and count($product->prices['VatTax'])>0){
						reset($product->prices['VatTax']);
						$rule = current($product->prices['VatTax']);
						if(isset($rule[1])){
							$product->prices['shipmentTax'] = $product->prices['shipmentPrice'] * $rule[1]/100.0;
							$product->prices['shipmentPrice'] = $product->prices['shipmentPrice'] * (1 + $rule[1]/100.0);
						}
					}

					$this->_currentMethod->{$mname} = $this->renderPluginName ($this->_currentMethod);
					$html[$this->_currentMethod->virtuemart_shipmentmethod_id] = $this->renderByLayout( 
						'product_page', 
						array(
							"plugin" => $this->_currentMethod, 
							"psType" => $this->_psType,
							"pluginSalesPrice" => $product->prices['shipmentPrice'],
							"currency" => $currency
						) 
					);
				}
			}
		}
		if(isset($cart)){
			unset($cart->products['single']);
			$cart->_productAdded = true;
			$cart->prepareCartData();
		}

		$productDisplayShipments[] = $html;

	}
	
	/**
	 * Это событие запускается после сохранения заказа; оно получает данные, 
	 * относящиеся к конкретному способу доставки.
	 *
	 * @param int    $order_id 	Идентификатор обрабатываемого заказа
	 * @param object $cart  	Корзина
	 * @param array  $order 	Фактический заказ, сохраненный в базе данных
	 * @return смешанный NULL если этот способ не был выбран, в противном случае значение TRUE
	 */
	function plgVmConfirmedOrder (VirtueMartCart $cart, $order) {

		if (!($method = $this->getVmPluginMethod ($order['details']['BT']->virtuemart_shipmentmethod_id))) {
			return NULL; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement ($method->shipment_element)) {
			return FALSE;
		}
		$values['virtuemart_order_id'] = $order['details']['BT']->virtuemart_order_id;
		$values['order_number'] = $order['details']['BT']->order_number;
		$values['virtuemart_shipmentmethod_id'] = $order['details']['BT']->virtuemart_shipmentmethod_id;
		$values['shipment_name'] = $this->renderPluginName ($method);
		$values['shipment_data'] = NULL;
		$values['shipment_id'] = NULL;
		$values['tracking_number'] = NULL;
		$values['status_name'] = vmText::_ ('VMSHIPMENT_BAIKAL_STATUS_0');
		$values['order_weight'] = $this->_getItemsWeight($cart->products, $method);
		$values['shipment_weight_unit'] = 'KG';
		$arDimensions = $this->_getItemsDimensions($cart->products, $method);
		$values['order_volume'] = $arDimensions['volume'];
		$values['shipment_lwh_unit'] = 'M';

		$costs = $this->getCosts($cart, $method, $cart->cartPrices);

		if(!empty($costs)){
			if(empty($method->additional_cost)) $method->additional_cost = 0.0;
			if(empty($method->additional_cost_percent)) $method->additional_cost_percent = 0.0;
			
			$values['shipment_cost'] = $costs - $method->additional_cost;
			$values['shipment_cost'] = $values['shipment_cost'] * 100 / (100 + $method->additional_cost_percent);
			$values['shipment_add_cost'] = $costs - $values['shipment_cost'];
		}
		if(empty($values['shipment_cost'])) $values['shipment_cost'] = 0.0;
		if(empty($values['shipment_add_cost'])) $values['shipment_add_cost'] = 0.0;
		$values['shipment_actual_cost'] = $values['shipment_cost'];
		$values['tax_id'] = $method->tax_id;
		$this->storePSPluginInternalData ($values);

		$extra = $this->renderByLayout( 'orderdone', array("method" => $this->_currentMethod, 'order' => $order, 'cart'=>$cart) );
		if(!empty($extra)){
			$cart->orderdoneHtml = $extra;
			// $cart->setCartIntoSession(false,true);
		}
		return TRUE;
	}
	
	/**
	 * Рассчет стоимости для выбранного способа доставки	
	 *
	 * @param VirtueMartCart $cart 			Объект корзины
	 * @param                $method 		Способ доставки
	 * @param                $cart_prices
	 * @return int
	 */
	function getCosts (VirtueMartCart $cart, $method, $cart_prices) {
		
		$total_price = $this->getCartAmount($cart_prices,true); //$cart_prices['salesPrice'];
		
		//Если подходит по условиям к бесплатной доставке
		if ($method->free_shipment && $total_price >= $method->free_shipment) {	
			return 0.0;
		}	
		
		//Установим ключ api для выполнения расчета
		if (isset($method->test) && isset($method->authKeyTest) && isset($method->authKey)){
			if($method->test){
				$this->baikalsrTools::defineAuthParams( $method->authKeyTest, true );
			}else{
				$this->baikalsrTools::defineAuthParams( $method->authKey, false );
			}				
		}
		
		$address = $this->_getAddressFromCart($cart);		
		$destination = $this->_getLocationWithGUIDFromAddress($address);
		
		$total_weight = $this->_getItemsWeight($cart->products, $method);		
		$total_dimensions = $this->_getItemsDimensions ($cart->products, $method);
	
		if(!empty($destination) && isset($destination['guid']) && !empty($destination['guid'])) {			
			$preorderData = array(
				'departure_guid' => $method->departure_guid,
				'departure_from_address' => $method->departure_from_address,
				'departure_street_guid' => $method->departure_street_guid,
				'departure_house' => $method->departure_house,
				'departure_housing' => $method->departure_housing,
				'departure_building' => $method->departure_building,
				'departure_prr' => $method->departure_prr,
				'departure_floor' => $method->departure_floor,
				'departure_lift' => $method->departure_lift,
				'destination_guid' => $destination['guid'],
				//'destination_affiliate_guid' => $destination['affiliate']['guid'] ? $destination['affiliate']['guid'] : $destination['guid'],
				'destination_to_address' => true,
				'estimated_cost' => $total_price,
				'packing_id' => $method->packing_id,
				'weight' => $total_weight,
				'length' => $total_dimensions['length'],
				'width' => $total_dimensions['width'],
				'height' => $total_dimensions['height'],
				'volume' => $total_dimensions['volume'],
			);
			jimport('joomla.cache.cache');
			$cache_id = preg_replace('/\s|\&|\.|\,|\-|\+/', '', 'baikalsr_calc-' . $method->departure_guid . $method->departure_from_address . $destination['guid'] . $total_weight . $total_dimensions["volume"] . $total_price . $method->packing_id);
			$conf = \JFactory::getConfig();
			$options = array(
				'defaultgroup' 	=> 'plg_baikalsr_shipping',
				'cachebase' 	=> $conf->get('cache_path', JPATH_CACHE),
				'lifetime' 		=> 10*60,
				'language' 		=> $conf->get('language', 'en-GB'),
				'storage' 		=> $conf->get('cache_handler', ''),
				'caching' 		=> true,
			);
			$cache = new \JCache($options);

			// Проверим есть ли кешированное значение
			if ($cache->contains($cache_id)){
				$calcResult = unserialize($cache->get($cache_id));
			}else{
				$calcResult = $this->baikalsrTools::calculate($preorderData);
				$cache->store(serialize($calcResult), $cache_id, 'plg_baikalsr_shipping');
			}
				
			if (isset($calcResult["total"]) && !empty($calcResult["total"])){
				if(empty($method->additional_cost)) $method->additional_cost = 0.0;
				if(empty($method->additional_cost_percent)) $method->additional_cost_percent = 0.0;
				
				$destination_total = 0;
				if(isset($calcResult["destination"]["total"]) && !empty($calcResult["total"]))
					$destination_total = (float)$calcResult["destination"]["total"];
				if($method->destination_to_address)
					return (float)$calcResult["total"] + $method->additional_cost + (float)$calcResult["total"] * $method->additional_cost_percent / 100;
				else
					return (float)$calcResult["total"] - $destination_total + $method->additional_cost + ((float)$calcResult["total"] - $destination_total) * $method->additional_cost_percent / 100;
				
				/*if($selected['additional']){
					$methods[$selected['key']]['terminals'] = [];
					$response = Tools::getAffiliateData($data['baikalsrAffiliateGuid']);
					if (isset($response["terminals"]) && !empty($response["terminals"])) {
						foreach($response["terminals"] as $terminal) {
							if(isset($terminal["finish"]) && $terminal["finish"]){
								$terminal["address"] = Tools::htmlspecialcharsBack($terminal["address"]);
								$methods[$selected['key']]['terminals'][] = array('id' => $terminal['id'], 'name' => $terminal['name']." (".$terminal["address"].")");
							}
						}
					}
				}*/
			}			
		}else{
			return 0.0;
		}

	}
	
	/**
	 * Этот метод запускается при отображении сведений о заказе в серверной части.
	 * Он отображает данные, относящиеся к конкретной отгрузке.
	 * ОБРАТИТЕ внимание, этот плагин не следует использовать для отображения полей формы, поскольку он вызывается вне формы! 
	 * Вместо этого используйте plgVmOnUpdateOrderBE() 
	 *
	 * @param integer $virtuemart_order_id Идентификатор заказа
	 * @param integer $virtuemart_shipmentmethod_id Идентификатор способа отправки заказа
	 * @return смешанный NULL для отправлений, которые не активны, HTML-текст в противном случае
	 */
	public function plgVmOnShowOrderBEShipment ($virtuemart_order_id, $virtuemart_shipmentmethod_id) {

		if (!($this->selectedThisByMethodId ($virtuemart_shipmentmethod_id)))
			return NULL;

		$html = $this->_getOrderShipmentHtml ($virtuemart_order_id);
		
		return $html;
	}

	/**
	 * Выводит информацию о доставке по конкретному заказу в административной части сайта
	 *
	 * @param $virtuemart_order_id
	 * @return string
	 */
	function _getOrderShipmentHtml ($virtuemart_order_id) {

		if (empty ($virtuemart_order_id)) {
			return 0;
		}
		//get shipment order by virtuemart_order_id
		$shipment = $this->_getShippingInfo($virtuemart_order_id);
		if (!count((array)$shipment)){
			return 0;
		}
		$currency = CurrencyDisplay::getInstance ();
		$tax = ShopFunctions::getTaxByID ($shipment->tax_id);
		$taxDisplay = is_array ($tax) ? $tax['calc_value'] . ' ' . $tax['calc_value_mathop'] : $shipment->tax_id;
		$taxDisplay = ($taxDisplay == -1) ? vmText::_ ('COM_VIRTUEMART_PRODUCT_TAX_NONE') : $taxDisplay;
												   
		$html = '<table id="baikalsr_shipping_table" class="adminlist table">' . "\n";
		$html .= $this->getHtmlHeaderBE ();
		$html .= $this->_getShippingInfoBody ($shipment);
		
		$html .= '</table>' . "\n";
		$html .= $this->renderByLayout( 
			'btn_toolbar', 
			array(
				"virtuemart_shipmentmethod_id" => $shipment->virtuemart_shipmentmethod_id, 
				"virtuemart_order_id" => $virtuemart_order_id,
				"shipment_id" => $shipment->shipment_id
			)
		);

		return $html;
	}	
	
	function _getShippingInfoBody ($shipment) {

		$currency = CurrencyDisplay::getInstance ();
		$tax = ShopFunctions::getTaxByID ($shipment->tax_id);
		$taxDisplay = is_array ($tax) ? $tax['calc_value'] . ' ' . $tax['calc_value_mathop'] : $shipment->tax_id;
		$taxDisplay = ($taxDisplay == -1) ? vmText::_ ('COM_VIRTUEMART_PRODUCT_TAX_NONE') : $taxDisplay;
												   
		$html = $this->getHtmlRowBE ('COM_VIRTUEMART_SHIPMENT_NAME', $shipment->shipment_name);
		//Вывод даты сдачи груза
		$departure_date = date("Y-m-d", strtotime("+1 day"));
		if(isset($shipment->shipment_data) && !empty($shipment->shipment_data)){	
			$sent_data = json_decode($shipment->shipment_data, true);
			if (isset($sent_data['departure_date'])) {
				$departure_date = $sent_data['departure_date'];
			}	
		}
		$row = $this->getHtmlRowBE ('VMSHIPMENT_BAIKAL_DEPARTURE_DATE', HTMLHelper::calendar($departure_date, 'departure_date', 'departure_date', '%Y-%m-%d', array('disabled' => 'disabled', 'readonly' => 'readonly'))); 
		$html .= empty($shipment->tracking_number) ? str_replace('<tr>','<tr class="hide">', $row) : $row;
		$html .= $this->getHtmlRowBE ('VMSHIPMENT_BAIKAL_STATUS', $shipment->status_name);
		if(!empty($shipment->tracking_number))		
			$html .= $this->getHtmlRowBE ('VMSHIPMENT_BAIKAL_TRACKING_NUMBER', $shipment->tracking_number);
		$html .= $this->getHtmlRowBE ('VMSHIPMENT_BAIKAL_CARGO_WEIGHT', $shipment->order_weight . ' ' . ShopFunctions::renderWeightUnit ($shipment->shipment_weight_unit));
		$html .= $this->getHtmlRowBE ('VMSHIPMENT_BAIKAL_CARGO_VOLUME', $shipment->order_volume . ' ' . $shipment->shipment_lwh_unit . '<sup>3</sup>');
		if($shipment->shipment_cost != $shipment->shipment_actual_cost)
			$html .= $this->getHtmlRowBE ('VMSHIPMENT_BAIKAL_COST', $currency->priceDisplay ($shipment->shipment_actual_cost). ' ' . '<strike>' . $currency->priceDisplay ($shipment->shipment_cost) . '</strike>');
		else
			$html .= $this->getHtmlRowBE ('VMSHIPMENT_BAIKAL_COST', $currency->priceDisplay ($shipment->shipment_cost));
		$html .= $this->getHtmlRowBE ('VMSHIPMENT_BAIKAL_ADDITIONAL_COST', $currency->priceDisplay ($shipment->shipment_add_cost));
		$html .= $this->getHtmlRowBE ('VMSHIPMENT_BAIKAL_TAX', $taxDisplay);
		

		return $html;
	}		
	
	public function _getShippingPopupData($virtuemart_order_id, $virtuemart_shipmentmethod_id, $post_data = array()) {
		if (!class_exists('VmHTML')) {
			require(JPATH_VM_ADMINISTRATOR . DS . 'helpers' . DS . 'html.php');
		}
		$orderModel = VmModel::getModel('orders');
		$order = $orderModel->getOrder($virtuemart_order_id);
		if(empty($order)){
			$msg=vmText::sprintf('VMSHIPMENT_BAIKAL_NO_ENTRY_FOUND', $virtuemart_order_id);
			return vmError($msg, $msg);
		}
		$currency = CurrencyDisplay::getInstance ();
		$config = $this->getVmPluginMethod ($virtuemart_shipmentmethod_id);
		if (isset($config->test) && isset($config->authKeyTest) && isset($config->authKey)){
			if($config->test){
				$this->baikalsrTools::defineAuthParams( $config->authKeyTest, true );
			}else{
				$this->baikalsrTools::defineAuthParams( $config->authKey, false );
			}				
		}
		$data['form_data'] = new stdClass();	
		//get shipment order by virtuemart_order_id
		$shipment = $this->_getShippingInfo($virtuemart_order_id);
		if (!count((array)$shipment)){
			$shipment = new stdClass();
		}
		if(isset($shipment->shipment_data) && !empty($shipment->shipment_data)){	
			$data['disabled'] = true;
			$sent_data = json_decode($shipment->shipment_data, true);
		}elseif(!empty($post_data)){
			$sent_data = $post_data;
			$data['warning'] = $this->_validateForm($sent_data);
			if(count((array)$data['warning']) == 0){
				$baikalResponse = $this->baikalsrTools::order(array_merge($sent_data, ['order_id' => $virtuemart_order_id]));
				$data['errors'] = new stdClass();
				if(empty($baikalResponse)) {
					$data['errors']->no_response = JText::_('VMSHIPMENT_BAIKAL_ERROR_API_NO_RESPONSE');
				}elseif(isset($baikalResponse["errors"]) && !empty($baikalResponse["errors"])) {
					$data['errors']->invalid_data = '';
					foreach($baikalResponse["errors"] as $errorData)
						if(isset($errorData["description"]) && !empty($errorData["description"]))
							$data['errors']->invalid_data .= $errorData["description"];
						else
							$data['errors']->invalid_data .= urldecode(str_replace("=", ": ", http_build_query($errorData,"", "\r\n")));							
				}elseif(!isset($baikalResponse["request_hash"]) || empty($baikalResponse["request_hash"])){
					$data['errors']->no_hash = JText::_('VMSHIPMENT_BAIKAL_ERROR_API_NO_HASH');
				}elseif(!isset($baikalResponse["request_id"]) || empty($baikalResponse["request_id"])){
					$data['errors']->no_request = JText::_('VMSHIPMENT_BAIKAL_ERROR_API_NO_REQUEST');
				}elseif(!isset($baikalResponse["tracknumbers"]) || empty($baikalResponse["tracknumbers"])){
					$data['errors']->no_tracking = JText::_('VMSHIPMENT_BAIKAL_ERROR_API_NO_TRACKING');
				}
				if(count((array)$data['errors']) == 0){
					$shipment->shipment_data = json_encode($sent_data);
					$shipment->shipment_id = $baikalResponse["request_id"];
					$shipment->tracking_number = array_shift($baikalResponse["tracknumbers"]);
					$shipment->order_weight = $sent_data["weight"];
					$shipment->order_volume = $sent_data["volume"];
			
					$this->storePSPluginInternalData ((array)$shipment);
					$data['disabled'] = true;	
					$data['success'] = true;						
				}
			}	
		}
		
		if(isset($shipment->shipment_id) && !empty($shipment->shipment_id)){	
			$data['form_data']->shipment_id = $shipment->shipment_id;
		}
		if(isset($shipment->tracking_number) && !empty($shipment->tracking_number)){	
			$data['form_data']->tracking_number = $shipment->tracking_number;
		}
		$data['form_data']->virtuemart_order_id = $virtuemart_order_id;
		$data['form_data']->virtuemart_shipmentmethod_id = $virtuemart_shipmentmethod_id;
		
		//API
		$data['form_data']->authKey = $config->authKey;
		$data['form_data']->authKeyTest = $config->authKeyTest;
		$data['form_data']->test_mode = $config->test;
		
		//Consignor
		if (isset($sent_data['consignor_contragent_id'])) {
			$data['form_data']->consignor_contragent_id = $sent_data['consignor_contragent_id'];
		} else {
			$data['form_data']->consignor_contragent_id = $config->consignor_contragent_id;
		}	
		if (isset($sent_data['author_lastname'])) {
			$data['form_data']->author_lastname = $sent_data['author_lastname'];
		} else {
			$data['form_data']->author_lastname = $config->author_lastname;
		}	
		if (isset($sent_data['author_firstname'])) {
			$data['form_data']->author_firstname = $sent_data['author_firstname'];
		} else {
			$data['form_data']->author_firstname = $config->author_firstname;
		}	
		if (isset($sent_data['author_middlename'])) {
			$data['form_data']->author_middlename = $sent_data['author_middlename'];
		} else {
			$data['form_data']->author_middlename = $config->author_middlename;
		}
		if (isset($sent_data['consignor_fio'])) {
			$data['form_data']->consignor_fio = $sent_data['consignor_fio'];
		} else {
			$data['form_data']->consignor_fio = $config->author_lastname.' '.$config->author_firstname.' '.$config->author_middlename;
		}			
		if (isset($sent_data['consignor_phone'])) {
			$data['form_data']->consignor_phone = $sent_data['consignor_phone'];
		} else {
			$data['form_data']->consignor_phone = $config->consignor_phone;
		}		
		if (isset($sent_data['consignor_email'])) {
			$data['form_data']->consignor_email = $sent_data['consignor_email'];
		} else {
			$data['form_data']->consignor_email = $config->consignor_email;
		}
		//Consignee	
		if (isset($sent_data['consignee_company'])) {
			$data['form_data']->consignee_company = $sent_data['consignee_company'];
		} else {
			$data['form_data']->consignee_company = '';
			if(isset($order['details']['BT']->company) && !empty($order['details']['BT']->company))
				$data['form_data']->consignee_company = $order['details']['BT']->company;
			if(isset($order['details']['ST']->company) && !empty($order['details']['ST']->company))
				$data['form_data']->consignee_company = $order['details']['ST']->company;			
		}
		$data['form_data']->consignee_company = htmlspecialchars_decode($data['form_data']->consignee_company);
		if (isset($sent_data['consignee_physical_person'])) {
			$data['form_data']->consignee_physical_person = $sent_data['consignee_physical_person'];
		} else {
			if (isset($data['form_data']->consignee_company) && !empty($data['form_data']->consignee_company)) {
				$data['form_data']->consignee_physical_person = 0;
			}else{
				$data['form_data']->consignee_physical_person = 1;
			}
		}
		if (isset($sent_data['consignee_inn'])) {
			$data['form_data']->consignee_inn = $sent_data['consignee_inn'];
		} else {
			$data['form_data']->consignee_inn = '';
			if(isset($order['details']['BT']->inn) && !empty($order['details']['BT']->inn))
				$data['form_data']->consignee_inn = $order['details']['BT']->inn;
			if(isset($order['details']['ST']->inn) && !empty($order['details']['ST']->inn))
				$data['form_data']->consignee_inn = $order['details']['ST']->inn;		
		}	
		if (isset($sent_data['consignee_kpp'])) {
			$data['form_data']->consignee_kpp = $sent_data['consignee_kpp'];
		} else {
			$data['form_data']->consignee_kpp = '';
			if(isset($order['details']['BT']->kpp) && !empty($order['details']['BT']->kpp))
				$data['form_data']->consignee_kpp = $order['details']['BT']->kpp;
			if(isset($order['details']['ST']->kpp) && !empty($order['details']['ST']->kpp))
				$data['form_data']->consignee_kpp = $order['details']['ST']->kpp;		
		}
		if (isset($sent_data['consignee_inn_kpp'])) {
			$data['form_data']->consignee_inn_kpp = $sent_data['consignee_inn_kpp'];
		} else {
			$data['form_data']->consignee_inn_kpp = trim($data['form_data']->consignee_inn . ' ' . $data['form_data']->consignee_kpp);
			$pos = strpos($data['form_data']->consignee_inn_kpp, ' ');
			if ($pos !== false) {
				$data['form_data']->consignee_inn_kpp = substr_replace($data['form_data']->consignee_inn_kpp, '/', $pos, strlen(' '));
			}
		}	
		if (isset($sent_data['consignee_fio'])) {
			$data['form_data']->consignee_fio = $sent_data['consignee_fio'];
		} else {
			$data['form_data']->consignee_fio = '';				
			if(isset($order['details']['ST']->last_name) && !empty($order['details']['ST']->last_name))
				$data['form_data']->consignee_fio .= $order['details']['ST']->last_name;
			if(isset($order['details']['ST']->first_name) && !empty($order['details']['ST']->first_name))
				$data['form_data']->consignee_fio .= ' ' . $order['details']['ST']->first_name;
			if(isset($order['details']['ST']->middle_name) && !empty($order['details']['ST']->middle_name))
				$data['form_data']->consignee_fio .= ' ' . $order['details']['ST']->middle_name;
			$data['form_data']->consignee_fio = trim($data['form_data']->consignee_fio);
			if(isset($data['form_data']->consignee_fio) && empty($data['form_data']->consignee_fio)){
				if(isset($order['details']['BT']->last_name) && !empty($order['details']['BT']->last_name))
					$data['form_data']->consignee_fio .= $order['details']['BT']->last_name;
				if(isset($order['details']['BT']->first_name) && !empty($order['details']['BT']->first_name))
					$data['form_data']->consignee_fio .= ' ' . $order['details']['BT']->first_name;
				if(isset($order['details']['BT']->middle_name) && !empty($order['details']['BT']->middle_name))
					$data['form_data']->consignee_fio .= ' ' . $order['details']['BT']->middle_name;
				$data['form_data']->consignee_fio = trim($data['form_data']->consignee_fio);	
			}
		}
		if (isset($sent_data['consignee_legal_opf_id'])) {
			$data['form_data']->consignee_legal_opf_id = $sent_data['consignee_legal_opf_id'];
		} else {
			$data['form_data']->consignee_legal_opf_id = 4;
		}
		if (isset($sent_data['consignee_physical_document_id'])) {
			$data['form_data']->consignee_physical_document_id = $sent_data['consignee_physical_document_id'];
		} else {
			$data['form_data']->consignee_physical_document_id = 1;
		}
		if (!isset($sent_data['consignee_no_document'])) {
			$data['form_data']->consignee_no_document = false;
		} else {
			$data['form_data']->consignee_no_document = $sent_data['consignee_no_document'];
		}
		if (isset($sent_data['consignee_seria'])) {
			$data['form_data']->consignee_seria = $sent_data['consignee_seria'];
		} else {
			$data['form_data']->consignee_seria = '';
			if(isset($order['details']['BT']->seria) && !empty($order['details']['BT']->seria))
				$data['form_data']->consignee_seria = $order['details']['BT']->seria;
			if(isset($order['details']['ST']->seria) && !empty($order['details']['ST']->seria))
				$data['form_data']->consignee_seria = $order['details']['ST']->seria;		
		}	
		if (isset($sent_data['consignee_number'])) {
			$data['form_data']->consignee_number = $sent_data['consignee_number'];
		} else {
			$data['form_data']->consignee_number = '';
			if(isset($order['details']['BT']->number) && !empty($order['details']['BT']->number))
				$data['form_data']->consignee_number = $order['details']['BT']->number;
			if(isset($order['details']['ST']->number) && !empty($order['details']['ST']->number))
				$data['form_data']->consignee_number = $order['details']['ST']->number;		
		}
		if (isset($sent_data['consignee_seria_number'])) {
			$data['form_data']->consignee_seria_number = $sent_data['consignee_seria_number'];
		} else {
			$data['form_data']->consignee_seria_number = trim($data['form_data']->consignee_seria . ' ' . $data['form_data']->consignee_number);
		}		
		if (isset($sent_data['consignee_phone'])) {
			$data['form_data']->consignee_phone = $sent_data['consignee_phone'];
		} else {
			if(isset($order['details']['BT']->phone_1) && !empty($order['details']['BT']->phone_1))
				$data['form_data']->consignee_phone = $order['details']['BT']->phone_1;
			if(isset($order['details']['ST']->phone_1) && !empty($order['details']['ST']->phone_1))
				$data['form_data']->consignee_phone = $order['details']['ST']->phone_1;
			if(isset($order['details']['BT']->phone_2) && !empty($order['details']['BT']->phone_2))
				$data['form_data']->consignee_phone = $order['details']['BT']->phone_2;
			if(isset($order['details']['ST']->phone_2) && !empty($order['details']['ST']->phone_2))
				$data['form_data']->consignee_phone = $order['details']['ST']->phone_2;				
		}
		if (isset($sent_data['consignee_email'])) {
			$data['form_data']->consignee_email = $sent_data['consignee_email'];
		} else {
			if(isset($order['details']['BT']->email) && !empty($order['details']['BT']->email))
				$data['form_data']->consignee_email = $order['details']['BT']->email;
			if(isset($order['details']['ST']->email) && !empty($order['details']['ST']->email))
				$data['form_data']->consignee_email = $order['details']['ST']->email;	
		}		
		if (isset($sent_data['departure_guid'])) {
			$data['form_data']->departure_guid = $sent_data['departure_guid'];
		} else {
			$data['form_data']->departure_guid = $config->departure_guid;
		}
		if (isset($sent_data['departure'])) {
			$data['form_data']->departure = $sent_data['departure'];
		} else {
			$data['form_data']->departure = $config->departure;
		}		
		if (isset($sent_data['departure_from_address'])) {
			$data['form_data']->departure_from_address = $sent_data['departure_from_address'];
		} else {
			$data['form_data']->departure_from_address = $config->departure_from_address;
		}
		if (isset($sent_data['departure_date'])) {
			$data['form_data']->departure_date = $sent_data['departure_date'];
		} else {
			if($data['form_data']->departure_from_address)
				$data['form_data']->departure_date = date("Y-m-d", strtotime("+1 day"));
			else
				$data['form_data']->departure_date = date("Y-m-d");
		}			
		if (isset($sent_data['departure_terminal_id'])) {
			$data['form_data']->departure_terminal_id = $sent_data['departure_terminal_id'];
		} else {
			$data['form_data']->departure_terminal_id = $config->departure_terminal_id;
		}
		if (isset($sent_data['departure_street_guid'])) {
			$data['form_data']->departure_street_guid = $sent_data['departure_street_guid'];
		} else {
			$data['form_data']->departure_street_guid = $config->departure_street_guid;
		}
		if (isset($sent_data['departure_street'])) {
			$data['form_data']->departure_street = $sent_data['departure_street'];
		} else {
			$data['form_data']->departure_street = $config->departure_street;
		}
		if (isset($sent_data['departure_house_guid'])) {
			$data['form_data']->departure_house_guid = $sent_data['departure_house_guid'];
		} else {
			$data['form_data']->departure_house_guid = $config->departure_house_guid;
		}
		if (isset($sent_data['departure_house'])) {
			$data['form_data']->departure_house = $sent_data['departure_house'];
		} else {
			$data['form_data']->departure_house = $config->departure_house;
		}
		if (isset($sent_data['departure_housing'])) {
			$data['form_data']->departure_housing = $sent_data['departure_housing'];
		} else {
			$data['form_data']->departure_housing = $config->departure_housing;
		}
		if (isset($sent_data['departure_building'])) {
			$data['form_data']->departure_building = $sent_data['departure_building'];
		} else {
			$data['form_data']->departure_building = $config->departure_building;
		}
		if (isset($sent_data['departure_apartment'])) {
			$data['form_data']->departure_apartment = $sent_data['departure_apartment'];
		} else {
			$data['form_data']->departure_apartment = $config->departure_apartment;
		}
		if (isset($sent_data['departure_comment'])) {
			$data['form_data']->departure_comment = $sent_data['departure_comment'];
		} else {
			$data['form_data']->departure_comment = $config->departure_comment;
		}
		if (isset($sent_data['departure_prr'])) {
			$data['form_data']->departure_prr = $sent_data['departure_prr'];
		} else {
			$data['form_data']->departure_prr = $config->departure_prr;
		}
		if (isset($sent_data['departure_floor'])) {
			$data['form_data']->departure_floor = $sent_data['departure_floor'];
		} else {
			$data['form_data']->departure_floor = $config->departure_floor;
		}
		if (isset($sent_data['departure_lift'])) {
			$data['form_data']->departure_lift = $sent_data['departure_lift'];
		} else {
			$data['form_data']->departure_lift = $config->departure_lift;
		}
		if (isset($sent_data['destination_guid'])) {
			$data['form_data']->destination_guid = $sent_data['destination_guid'];
		} else {
			$data['form_data']->destination_guid = '';
			if(isset($order['details']['BT']->baikalsr_city) && !empty($order['details']['BT']->baikalsr_city))
				$data['form_data']->destination_guid = $order['details']['BT']->baikalsr_city;
			if(isset($order['details']['ST']->baikalsr_city) && !empty($order['details']['ST']->baikalsr_city))
				$data['form_data']->destination_guid = $order['details']['ST']->baikalsr_city;
		}
		/*
		Отключена доставка в ближайший город, если нет представительсва в нем
		if (isset($sent_data['destination_affiliate_guid'])) {
			$data['form_data']->destination_affiliate_guid = $sent_data['destination_affiliate_guid'];
		}else{
			$data['form_data']->destination_affiliate_guid = '';
		}*/					
		if (isset($sent_data['destination'])) {
			$data['form_data']->destination = $sent_data['destination'];
		} else {
			$data['form_data']->destination = '';
			if(isset($order['details']['BT']->city) && !empty($order['details']['BT']->city))
				$data['form_data']->destination = $order['details']['BT']->city;
			if(isset($order['details']['ST']->city) && !empty($order['details']['ST']->city))
				$data['form_data']->destination = $order['details']['ST']->city;	
		}
		if (isset($sent_data['destination_to_address'])) {
			$data['form_data']->destination_to_address = $sent_data['destination_to_address'];
		} else {
			$data['form_data']->destination_to_address = $config->destination_to_address;
		}
		if (isset($sent_data['destination_date'])) {
			$data['form_data']->destination_date = $sent_data['destination_date'];
		} else {
			if($data['form_data']->departure_from_address && !$data['form_data']->destination_to_address)
				$data['form_data']->destination_date = date("Y-m-d", strtotime("+2 day"));
			elseif($data['form_data']->departure_from_address && $data['form_data']->destination_to_address)
				$data['form_data']->destination_date = date("Y-m-d", strtotime("+3 day"));
			elseif(!$data['form_data']->departure_from_address && $data['form_data']->destination_to_address)
				$data['form_data']->destination_date = date("Y-m-d", strtotime("+2 day"));
			else
				$data['form_data']->destination_date = date("Y-m-d", strtotime("+1 day"));
		}			
		if (isset($sent_data['departure_terminal_id'])) {
			$data['form_data']->destination_terminal_id = $sent_data['destination_terminal_id'];
		} 
		if (isset($sent_data['destination_street_guid'])) {
			$data['form_data']->destination_street_guid = $sent_data['destination_street_guid'];
		} else {
			$data['form_data']->destination_street_guid = '';
		}	
		if (isset($sent_data['destination_street'])) {
			$data['form_data']->destination_street = $sent_data['destination_street'];
		} else {
			$data['form_data']->destination_street = '';
		}
		if (isset($sent_data['destination_house_guid'])) {
			$data['form_data']->destination_house_guid = $sent_data['destination_house_guid'];
		} else {
			$data['form_data']->destination_house_guid = '';
		}
		if (isset($sent_data['destination_house'])) {
			$data['form_data']->destination_house = $sent_data['destination_house'];
		} else {
			$data['form_data']->destination_house = '';
		}
		if (isset($sent_data['destination_housing'])) {
			$data['form_data']->destination_housing = $sent_data['destination_housing'];
		} else {
			$data['form_data']->destination_housing = '';
		}
		if (isset($sent_data['destination_building'])) {
			$data['form_data']->destination_building = $sent_data['destination_building'];
		} else {
			$data['form_data']->destination_building = '';
		}
		if (isset($sent_data['destination_apartment'])) {
			$data['form_data']->destination_apartment = $sent_data['destination_apartment'];
		} else {
			$data['form_data']->destination_apartment = '';
		}
		if (isset($sent_data['destination_comment'])) {
			$data['form_data']->destination_comment = $sent_data['destination_comment'];
		} else {
			$data['form_data']->destination_comment = '';
			if(isset($order['details']['BT']->virtuemart_state_id) && !empty($order['details']['BT']->virtuemart_state_id))
				$data['form_data']->destination_comment = ShopFunctions::getStateByID($order['details']['BT']->virtuemart_state_id);
			if(isset($order['details']['ST']->virtuemart_state_id) && !empty($order['details']['ST']->virtuemart_state_id))
				$data['form_data']->destination_comment = ShopFunctions::getStateByID($order['details']['ST']->virtuemart_state_id);	
			$data['form_data']->destination_comment .= ' ' . $data['form_data']->destination . ' ';
			if(isset($order['details']['BT']->address_1) && !empty($order['details']['BT']->address_1)){
				$data['form_data']->destination_comment .= $order['details']['BT']->address_1;
				if(isset($order['details']['BT']->address_2) && !empty($order['details']['BT']->address_2))
					$data['form_data']->destination_comment .= ' ' . $order['details']['BT']->address_2;
			}elseif(isset($order['details']['ST']->address_1) && !empty($order['details']['ST']->address_1)){
				$data['form_data']->destination_comment .=  $order['details']['ST']->address_1;
				if(isset($order['details']['ST']->address_2) && !empty($order['details']['ST']->address_2))
					$data['form_data']->destination_comment .= ' ' . $order['details']['ST']->address_2;
			}
			$data['form_data']->destination_comment = trim($data['form_data']->destination_comment);
		}
		if (isset($sent_data['destination_prr'])) {
			$data['form_data']->destination_prr = $sent_data['destination_prr'];
		} else {
			$data['form_data']->destination_prr = 0;
		}
		if (isset($sent_data['destination_floor'])) {
			$data['form_data']->destination_floor = $sent_data['destination_floor'];
		} else {
			$data['form_data']->destination_floor = '';
		}
		if (isset($sent_data['destination_lift'])) {
			$data['form_data']->destination_lift = $sent_data['destination_lift'];
		} else {
			$data['form_data']->destination_lift = 1;
		}
		if (isset($sent_data['cargotype_id'])) {
			$data['form_data']->cargotype_id = $sent_data['cargotype_id'];
		} else {
			$data['form_data']->cargotype_id = $config->cargotype_id;
		}					
		if (isset($sent_data['packing_id'])) {
			$data['form_data']->packing_id = $sent_data['packing_id'];
		} else {
			$data['form_data']->packing_id = $config->packing_id;
		}		
		$prodDimensions = $this->_getItemsDimensions($order['items'], $config);
		if (isset($sent_data['volume'])) {
			$data['form_data']->volume = $sent_data['volume'];
		} else {
			$data['form_data']->volume = $prodDimensions['volume'];
		}	
		if (isset($sent_data['weight'])) {
			$data['form_data']->weight = $sent_data['weight'];
		} else {
			$data['form_data']->weight = $this->_getItemsWeight($order['items'], $config);
		}	
		if (isset($sent_data['length'])) {
			$data['form_data']->length = $sent_data['length'];
		} else {
			$data['form_data']->length = $prodDimensions['length'];
		}	
		if (isset($sent_data['width'])) {
			$data['form_data']->width = $sent_data['width'];
		} else {
			$data['form_data']->width = $prodDimensions['width'];
		}	
		if (isset($sent_data['height'])) {
			$data['form_data']->height = $sent_data['height'];
		} else {
			$data['form_data']->height = $prodDimensions['height'];
		}	
		if (isset($sent_data['estimated_cost'])) {
			$data['form_data']->estimated_cost = $sent_data['estimated_cost'];
		} else {
			if(isset($order['details']['BT']->order_subtotal) && !empty($order['details']['BT']->order_subtotal))
				$data['form_data']->estimated_cost = $currency->roundForDisplay($order['details']['BT']->order_subtotal);
			if(isset($order['details']['ST']->order_subtotal) && !empty($order['details']['ST']->order_subtotal))
				$data['form_data']->estimated_cost = $currency->roundForDisplay($order['details']['ST']->order_subtotal);	
		}	

		
		//Выполним расчет стоимости
		//$calcResult = $this->baikalsrTools::calculate((array)$data['form_data']);

		
		return $data;
	}	
	
	public function _getShippingInfo($virtuemart_order_id)
    {
		$db = JFactory::getDBO ();
		$q = 'SELECT * FROM `' . $this->_tablename . '` '
			. 'WHERE `virtuemart_order_id` = ' . $virtuemart_order_id;
		$db->setQuery ($q);
		if (!($result = $db->loadObject ())) {
			$msg=vmText::sprintf('VMSHIPMENT_BAIKAL_NO_ENTRY_FOUND', $virtuemart_order_id);
			vmWarn ($msg);
			vmDebug($msg, $q . " " . $db->getErrorMsg ());
			return '';
		}
		return $result;
	}
	
	public function _getPreferredTerminal($address_id)
    {
		/*$db = JFactory::getDBO();
		$query = 'SELECT destination_terminal_id  FROM ' . hikashop_table('plg_baikalsr_address') . ' WHERE address_id = ' . $address_id . ' LIMIT 1';
		$db -> setQuery($query);
		return $db -> loadResult();*/
		return 11;
	}	
	
	/**
	 * Расчет общего веса товаров с учетом значений по умолчанию для товаров в которых 
	 * не заполнен вес.
	 *
	 * @param VirtueMartCart $cart 			Объект корзины
	 * @param                $method 		Способ доставки
	 * @return float Общий вес товаров
	 */	
	function _getItemsDimensions($items, $method, $to_lwh_unit = 'M') {
        $arDimensions = array();
		$defaultForItem = $method->default_for_item;
		$defLength = ShopFunctions::convertDimensionUnit ($method->lengthD, $method->lwh_unit, $to_lwh_unit);
		$defWidth = ShopFunctions::convertDimensionUnit ($method->widthD, $method->lwh_unit, $to_lwh_unit);
		$defHeight = ShopFunctions::convertDimensionUnit ($method->heightD, $method->lwh_unit, $to_lwh_unit);
        $totalVolume1 = 0;
        $totalVolume2 = 0;
        $maxLength = 0;
        $maxWidth = 0;
        $maxHeight = 0;
        //max dimension
        foreach ($items as $product) {
			//Если расчет идет из карточки товара, то игнорируем товары уже добавленные в корзину			
			if(isset($items['single']))
				$product = $items['single'];
			if(!empty((float) $product->product_length) && !empty((float) $product->product_width) && !empty((float) $product->product_height) && !empty($product->product_lwh_uom)){
				$length = ShopFunctions::convertDimensionUnit ($product->product_length, $product->product_lwh_uom, $to_lwh_unit);
				$width = ShopFunctions::convertDimensionUnit ($product->product_width, $product->product_lwh_uom, $to_lwh_unit);
				$height = ShopFunctions::convertDimensionUnit ($product->product_height, $product->product_lwh_uom, $to_lwh_unit);
				$totalVolume1 += $product->quantity * $length * $width * $height;
			}else{
				$length = $defLength;
				$width = $defWidth;
				$height = $defHeight;
				if($defaultForItem)
					$totalVolume2 += $product->quantity * $defLength * $defWidth * $defHeight;
				else
					$totalVolume2 = $defLength * $defWidth * $defHeight;
			}
			if($length > $maxLength) $maxLength = $length;
			if($width > $maxWidth) $maxWidth = $width;
			if($height > $maxHeight) $maxHeight = $height;
			if(isset($items['single']))
				break;
        }
		$arDimensions['length']= $maxLength;
        $arDimensions['width'] = $maxWidth;
        $arDimensions['height'] = $maxHeight;
		$arDimensions['volume'] = round($totalVolume1 + $totalVolume2, 3);
        return $arDimensions;
    }	
	
	/**
	 * Расчет общего веса товаров с учетом значений по умолчанию для товаров в которых 
	 * не заполнен вес.
	 *
	 * @param VirtueMartCart $cart 			Объект корзины
	 * @param                $method 		Способ доставки
	 * @return float Общий вес товаров
	 */	
	function _getItemsWeight($items, $method, $to_weight_unit = 'KG') {
		$defaultForItem = $method->default_for_item;
		//$to_weight_unit = VmConfig::get('weight_unit_default','KG');
		$defWeight = ShopFunctions::convertWeightUnit ($method->weightD, $method->weight_unit, $to_weight_unit);
		$totalWeight1 = 0;
		$totalWeight2 = 0;
        foreach ($items as $product) {
			//Если расчет идет из карточки товара, то игнорируем товары уже добавленные в корзину
			if(isset($items['single']))
				$product = $items['single'];
			if(!empty((float) $product->product_weight) && !empty($product->product_weight_uom)){	
				$totalWeight1 += (ShopFunctions::convertWeightUnit ($product->product_weight, $product->product_weight_uom, $to_weight_unit) * $product->quantity);
			}else{
				if($defaultForItem)
					$totalWeight2 += $product->quantity * $defWeight;
				else
					$totalWeight2 = $defWeight;
			}
			if(isset($items['single']))
				break;
        }
		return round($totalWeight1 + $totalWeight2, 3);
    }

	/**
	 * @param \VirtueMartCart $cart Объект корзины
	 * @param int             $method
	 * @param array           $cart_prices
	 * @return bool
	 */
	protected function checkConditions ($cart, $method, $cart_prices) {

		static $result = array();
		
		//Установим ключ API
		if (isset($method->test) && isset($method->authKeyTest) && isset($method->authKey)){
			if($method->test){
				$this->baikalsrTools::defineAuthParams( $method->authKeyTest, true );
			}else{
				$this->baikalsrTools::defineAuthParams( $method->authKey, false );
			}				
		}
		
		$address = $this->_getAddressFromCart($cart);
		
		if(isset($cart_prices['salesPrice'])){
			$hashSalesPrice = $this->getCartAmount($cart_prices,true); //$cart_prices['salesPrice'];
		} else {
			$hashSalesPrice = '';
		}

		$hash = $method->virtuemart_shipmentmethod_id.'_'.$address['virtuemart_country_id'].'_'.$address['virtuemart_state_id'].'_'.$address['city'].'_'.$address['baikalsr_city'].'_'.$hashSalesPrice;

		if(isset($result[$hash])){
			return $result[$hash];
		}

		$this->convert ($method);

		$result[$hash] = parent::checkConditions($cart, $method, $cart_prices);

		if(!$result[$hash]) return false;

		$orderWeight = $this->_getItemsWeight ($cart->products, $method, $method->limit_weight_unit);	
		$weight_cond = $this->_testRange($orderWeight, $method, 'weight_start', 'weight_stop', vmText::_ ('VMSHIPMENT_BAIKAL_CARGO_WEIGHT'));
		
		$arDimensions = $this->_getItemsDimensions ($cart->products, $method, $method->limit_lwh_unit);
		$volume_cond = $this->_testRange($arDimensions['volume'], $method, 'volume_start', 'volume_stop', vmText::_ ('VMSHIPMENT_BAIKAL_CARGO_VOLUME'));
		
		$destination = $this->_getLocationWithGUIDFromAddress($address);
		if(isset($destination['guid']) && !empty($destination['guid'])) {
			$city_cond = $this->_testEntry($destination['guid'], $method, 'blocking_destinations', vmText::_ ('VMSHIPMENT_BAIKAL_BLOCKING_DESTINATIONS'), false);
		}else{
			$city_cond = false;			
		}
		//Проверим есть ли терминалы в городе получения
		if($method->destination_to_address){
			$terminal_cond = true;
		}else{
			$terminal_cond = false;
			if(isset($destination['guid']) && !empty($destination['guid'])) {
				$response = $this->baikalsrTools::_getAffiliateData($destination['guid']);
				if (isset($response["terminals"]) && !empty($response["terminals"])) {
					foreach($response["terminals"] as $data) 
						if (isset($data['finish']) && $data['finish']) {
							$terminal_cond = true;
							break;
						}
				}
			}
		}
		
		$allconditions = (int) $weight_cond + (int)$volume_cond + (int)$city_cond + (int)$terminal_cond; 

		if($allconditions === 4){
			$result[$hash] = true;
			return TRUE;
		} else {
			$result[$hash] = false;
			//vmdebug('checkConditions '.$method->shipment_name.' does not fit ',(int)$weight_cond,(int)$zip_cond,(int)$nbproducts_cond,(int)$orderamount_cond,(int)$country_cond);
			return FALSE;
		}

		$result[$hash] = false;
		return FALSE;
	}

	/**
	 * Получить пункт с идентификатором из адреса	
	 *
	 * @param VirtueMartCart $cart 			Объект корзины
	 * @return array
	 */
	function _getLocationWithGUIDFromAddress ($address) {		

		$arCity = [];
		if(!empty($address['baikalsr_city'])){
			$arCity = $this->baikalsrTools::_getCityByGuid($address['baikalsr_city']);
		}else if(!empty($address['city'])){
			$city = preg_replace('/\s+/', '+', trim($address['city']));
			$arCity = $this->baikalsrTools::_getCityByName($city);		
		}else if(!empty($address['virtuemart_state_id'])){
			$state = ShopFunctions::getStateByID($address['virtuemart_state_id']);
			$state = preg_replace('/\s+/', '+', trim($state));
			$arCity = $this->baikalsrTools::_getCityByName($state);	
		}
	
		return $arCity;
	}
	
	/**
	 * Получить адрес из корзины	
	 *
	 * @param VirtueMartCart $cart 			Объект корзины
	 * @return array
	 */
	function _getAddressFromCart (VirtueMartCart $cart) {		

		$address = array();
		if(isset($cart->BT['virtuemart_country_id']) && !empty($cart->BT['virtuemart_country_id'])) $address['virtuemart_country_id'] = $cart->BT['virtuemart_country_id'];
		if(isset($cart->ST['virtuemart_country_id']) && !empty($cart->ST['virtuemart_country_id'])) $address['virtuemart_country_id'] = $cart->ST['virtuemart_country_id'];
		if(isset($cart->BT['virtuemart_state_id']) && !empty($cart->BT['virtuemart_state_id'])) $address['virtuemart_state_id'] = $cart->BT['virtuemart_state_id'];
		if(isset($cart->ST['virtuemart_state_id']) && !empty($cart->ST['virtuemart_state_id'])) $address['virtuemart_state_id'] = $cart->ST['virtuemart_state_id'];
		if(isset($cart->BT['city']) && !empty($cart->BT['city'])) $address['city'] = $cart->BT['city'];
		if(isset($cart->ST['city']) && !empty($cart->ST['city'])) $address['city'] = $cart->ST['city'];
		if(isset($cart->BT['baikalsr_city']) && !empty($cart->BT['baikalsr_city'])) $address['baikalsr_city'] = $cart->BT['baikalsr_city'];
		if(isset($cart->ST['baikalsr_city']) && !empty($cart->ST['baikalsr_city'])) $address['baikalsr_city'] = $cart->ST['baikalsr_city'];		
		
		if(!isset($address['virtuemart_country_id']) || empty($address['virtuemart_country_id'])) $address['virtuemart_country_id'] = 0;
		if(!isset($address['virtuemart_state_id']) || empty($address['virtuemart_state_id'])) $address['virtuemart_state_id'] = 0;
		if(!isset($address['city']) || empty($address['city'])) $address['city'] = '';
		if(!isset($address['baikalsr_city']) || empty($address['baikalsr_city'])) $address['baikalsr_city'] = '';
	
		return $address;
	}
	
	/**
	 * @param $method
	 */
	function convert (&$method) {
		$method->lengthD = (float) $method->lengthD;
		$method->widthD = (float) $method->widthD;
		$method->heightD = (float) $method->heightD;
		$method->weightD = (float) $method->weightD;
		$method->weight_start = (float) $method->weight_start;
		$method->weight_stop = (float) $method->weight_stop;
		$method->volume_start = (float) $method->volume_start;
		$method->volume_stop = (float) $method->volume_stop;
		$method->additional_cost_percent = (float) $method->additional_cost_percent;
		$method->additional_cost = (float) $method->additional_cost;
		$method->free_shipment = (float) $method->free_shipment;
	}
	
	/** Проверка значения количество товаров в корзине
	 * @param $value 
	 * @param $method
	 * @return bool
	 */
	private function _testEntry ($value, $method, $checklist, $name, $cond) {
		if(!isset($method->$checklist) || !is_array($method->$checklist))
			$method->$checklist = array();
		if (count ($method->$checklist) > 0 and in_array ($value, $method->$checklist) ) {
			if(!$cond){
				$result = FALSE;
			} else {
				$result = TRUE;
			}
			$reason = vmText::sprintf('VMSHIPMENT_BAIKAL_IS_IN_LIST', implode(', ', $method->$checklist));
		}else{
			if(!$cond){
				$result = TRUE;
			} else {
				$result = FALSE;
			}
			$reason = vmText::sprintf('VMSHIPMENT_BAIKAL_IS_NOT_IN_LIST', implode(', ', $method->$checklist));
		}

		if(!$result) {
			$msg = 'shipmentmethod '.$method->shipment_name.' = '.(string)$result . ' ';
			$msg .= vmText::_ ('VMSHIPMENT_BAIKAL_FOR_VARIABLE'). ' ' .$name.' = '.$value . ' ';
			$msg .= vmText::_ ('VMSHIPMENT_BAIKAL_REASON') . ' ' .$reason;
			vmdebug($msg);
		}
		return $result;
	}

	/**
	 * Проверка значения на превышение максимальных и минимальных ограничений
	 * @param $value Объект корзины
	 * @param $method Способ доставки
	 * @param $floor Минимальное значение
	 * @param $ceiling Максимальное значение
	 * @param $name Имя переменной	 
	 * @return bool
	 */
	private function _testRange($value, $method, $floor, $ceiling, $name){

		$cond = true;
		if(!empty($method->$floor) and !empty($method->$ceiling)){
			$cond = (($value >= $method->$floor AND $value <= $method->$ceiling));
			if(!$cond){
				$result = 'FALSE';
				$reason = vmText::sprintf('VMSHIPMENT_BAIKAL_IS_NOT_IN_RANGE', $method->$floor, $method->$ceiling);
			} else {
				$result = 'TRUE';
				$reason = vmText::sprintf('VMSHIPMENT_BAIKAL_IS_IN_RANGE', $method->$floor, $method->$ceiling);
			}
		} else if(!empty($method->$floor)){
			$cond = ($value >= $method->$floor);
			if(!$cond){
				$result = 'FALSE';
				$reason = vmText::sprintf('VMSHIPMENT_BAIKAL_IS_NOT_AT_LEAST', $method->$floor);
			} else {
				$result = 'TRUE';
				$reason = vmText::sprintf('VMSHIPMENT_BAIKAL_IS_OVER_MIN_LIMIT', $method->$floor);
			}
		} else if(!empty($method->$ceiling)){
			$cond = ($value <= $method->$ceiling);
			if(!$cond){
				$result = 'FALSE';
				$reason = vmText::sprintf('VMSHIPMENT_BAIKAL_IS_OVER', $method->$ceiling);
			} else {
				$result = 'TRUE';
				$reason = vmText::sprintf('VMSHIPMENT_BAIKAL_IS_LOWER_THAN_THE_SET', $method->$ceiling);
			}
		} else {
			$result = 'TRUE';
			$reason = vmText::_ ('VMSHIPMENT_BAIKAL_NO_CONDITIONS_SET');
		}
		
		if(!$result) {
			$msg = 'shipmentmethod '.$method->shipment_name.' = '.$result . ' ';
			$msg .= vmText::_ ('VMSHIPMENT_BAIKAL_FOR_VARIABLE'). ' ' .$name.' = '.$value . ' ';
			$msg .= vmText::_ ('VMSHIPMENT_BAIKAL_REASON') . ' ' .$reason;
			vmdebug($msg);
		}
		return $cond;
	}
	
	protected function _prepareData($data) {
		$new_data = [];
		foreach ( $data as $key => $value )
		{
			if(strpos($key, 'shipping_baikalsr_')!== false)
				$new_data[str_replace('shipping_baikalsr_', '', $key)] = $value;
		}
		return $new_data;
	}	
	
	protected function _validateForm($form_data) {

		$warning = new stdClass();
		if(!isset($form_data['consignor_contragent_id']) || $form_data['consignor_contragent_id'] == ''
			|| $form_data['consignor_contragent_id'] == '-1')
			$warning->consignor_contragent = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_CONTRAGENT');
		if(!isset($form_data['consignor_fio']) || $form_data['consignor_fio'] == '')
			$warning->consignor_fio = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_FIO');
		if(!isset($form_data['author_firstname']) || $form_data['author_firstname'] == '')
			$warning->consignor_fio = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_FIO');
		if(!isset($form_data['author_middlename']) || $form_data['author_middlename'] == '')
			$warning->consignor_fio = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_FIO');
		if(!isset($form_data['author_lastname']) || $form_data['author_lastname'] == '')
			$warning->consignor_fio = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_FIO');
		if(!isset($form_data['consignor_phone']) || $form_data['consignor_phone'] == '')
			$warning->consignor_phone = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_PHONE');
		elseif(strlen(preg_replace('![^0-9]+!', '', $form_data['consignor_phone'])) < 11)
			$warning->consignor_phone = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NOT_CORRECT_PHONE');
		if(!isset($form_data['consignor_email']) || $form_data['consignor_email'] == '')
			$warning->consignor_email = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_EMAIL');
		if(isset($form_data['consignee_physical_person']) && $form_data['consignee_physical_person'] != '1'){
			if(!isset($form_data['consignee_company']) || $form_data['consignee_company'] == '')
				$warning->consignee_company = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_COMPANY_NAME');
			if(!isset($form_data['consignee_legal_opf_id']) || $form_data['consignee_legal_opf_id'] == '' 
				|| $form_data['consignee_legal_opf_id'] == '-1')
				$warning->consignee_legal_opf = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_OPF');
			if(!isset($form_data['consignee_inn_kpp']) || $form_data['consignee_inn_kpp'] == ''){
				$warning->consignee_inn_kpp = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_INN_KPP');	
			}elseif(isset($form_data['consignee_legal_opf_id']) && !empty($form_data['consignee_legal_opf_id']) 
			&& $form_data['consignee_legal_opf_id'] != '9'){
				if( strlen(preg_replace('/[^0-9.]/', '', $form_data['consignee_inn']))<10)
					$warning->consignee_inn_kpp = vmText::sprintf('VMSHIPMENT_BAIKAL_ERROR_NOT_CORRECT_INN', '10');	
				if( strlen(preg_replace('/[^0-9.]/', '', $form_data['consignee_kpp']))<9)
					$warning->consignee_inn_kpp= vmText::sprintf('VMSHIPMENT_BAIKAL_ERROR_NOT_CORRECT_KPP', '9');					
			}elseif(isset($form_data['consignee_legal_opf_id']) && !empty($form_data['consignee_legal_opf_id']) 
			&& $form_data['consignee_legal_opf_id'] == '9' && strlen(preg_replace('/[^0-9.]/', '', $form_data['consignee_inn']))<12){
				$warning->consignee_inn_kpp = vmText::sprintf('VMSHIPMENT_BAIKAL_ERROR_NOT_CORRECT_INN', '12');	
			}
		}
		if(!isset($form_data['consignee_fio']) || $form_data['consignee_fio'] == '')
			$warning->consignee_fio = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_FIO');			
		if(isset($form_data['consignee_physical_person']) && $form_data['consignee_physical_person'] == '1'){
			if(!isset($form_data['consignee_no_document']) || $form_data['consignee_no_document'] != '1'){
				if(!isset($form_data['consignee_physical_document_id']) || $form_data['consignee_physical_document_id'] == '' 
					|| $form_data['consignee_physical_document_id'] == '-1')
					$warning->consignee_physical_document = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_DOCUMENT');	
				if(!isset($form_data['consignee_seria_number']) || $form_data['consignee_seria_number'] == '')
					$warning->consignee_seria_number = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_SERIA_NUMBER');		
			}
		}
		if(!isset($form_data['consignee_phone']) || $form_data['consignee_phone'] == '')
			$warning->consignee_phone = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_PHONE');
		elseif(strlen(preg_replace('![^0-9]+!', '', $form_data['consignee_phone'])) < 11)
			$warning->consignee_phone = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NOT_CORRECT_PHONE');
		if(!isset($form_data['consignee_email']) || $form_data['consignee_email'] == '')
			$warning->consignee_email = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_EMAIL');
		if(!isset($form_data['departure_guid']) || $form_data['departure_guid'] == '')
			$warning->departure = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_DEPARTURE');
		if(!isset($form_data['departure']) || $form_data['departure'] == '')
			$warning->departure = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_DEPARTURE');
		if(isset($form_data['departure_from_address']) && $form_data['departure_from_address'] != '1'){
			if(!isset($form_data['departure_terminal_id']) || $form_data['departure_terminal_id'] == '' 
				|| $form_data['departure_terminal_id'] == '-1')
				$warning->departure_terminal_id = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_TERMINAL');					
		}	
		if(isset($form_data['departure_from_address']) && $form_data['departure_from_address'] == '1'){
			if(!isset($form_data['departure_street_guid']) || $form_data['departure_street_guid'] == '')
				$warning->departure_street = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_STREET');		
			if(!isset($form_data['departure_street']) || $form_data['departure_street'] == '')
				$warning->departure_street = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_STREET');		
			//Можно вводить дом без классификатора
			//if(!isset($form_data['departure_house_guid']) || $form_data['departure_house_guid'] == '')
			//	$warning->departure_house = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_HOUSE');		
			if(!isset($form_data['departure_house']) || $form_data['departure_house'] == '')
				$warning->departure_house = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_HOUSE');	
			if(isset($form_data['departure_prr']) && $form_data['departure_prr'] == '1'){
				if(!isset($form_data['departure_floor']) || $form_data['departure_floor'] == '')
					$warning->departure_floor = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_FLOOR');	
			}
		}	
		if(!isset($form_data['destination_guid']) || $form_data['destination_guid'] == '')
			$warning->destination = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_DESTINATION');
		if(!isset($form_data['destination']) || $form_data['destination'] == '')
			$warning->destination = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_DESTINATION');
		if(isset($form_data['destination_to_address']) && $form_data['destination_to_address'] != '1'){
			if(!isset($form_data['destination_terminal_id']) || $form_data['destination_terminal_id'] == '' 
				|| $form_data['destination_terminal_id'] == '-1')
				$warning->destination_terminal_id = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_TERMINAL');					
		}			
		if(isset($form_data['destination_to_address']) && $form_data['destination_to_address'] == '1'){
			if(!isset($form_data['destination_street_guid']) || $form_data['destination_street_guid'] == '')
				$warning->destination_street = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_STREET');		
			if(!isset($form_data['destination_street']) || $form_data['destination_street'] == '')
				$warning->destination_street = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_STREET');		
			//Можно вводить дом без классификатора
			//if(!isset($form_data['destination_house_guid']) || $form_data['destination_house_guid'] == '')
			//	$warning->destination_house = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_HOUSE');		
			if(!isset($form_data['destination_house']) || $form_data['destination_house'] == '')
				$warning->destination_house = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_HOUSE');	
			if(isset($form_data['destination_prr']) && $form_data['destination_prr'] == '1'){
				if(!isset($form_data['destination_floor']) || $form_data['destination_floor'] == '')
					$warning->destination_floor = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_FLOOR');	
			}
		}	
		if(!isset($form_data['cargotype_id']) || $form_data['cargotype_id'] == '' 
			|| $form_data['cargotype_id'] == '-1')
			$warning->cargotype = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_CARGOTYPE');			
		if(!isset($form_data['volume']) || $form_data['volume'] == '' 
			|| $form_data['volume'] == '0')
			$warning->volume = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_VOLUME');		
		if(!isset($form_data['weight']) || $form_data['weight'] == '' 
			|| $form_data['weight'] == '0')
			$warning->weight = vmText::_('VMSHIPMENT_BAIKAL_ERROR_NO_WEIGHT');					

		return $warning;
	}
	
	/**
	 * Это событие запускается после выбора способа оплаты. 
	 * Его можно использовать для сохранения дополнительной информации об оплате в корзине.
	 * 	 
	 * @param VirtueMartCart $cart Объект корзины
	 * @return null, если способ оплаты не выбран
	 */
	public function plgVmOnSelectCheckShipment (VirtueMartCart &$cart) {

		return $this->OnSelectCheck ($cart);
	}

	/**
	 * @param VirtueMartCart $cart
	 * @param array          $cart_prices
	 * @param                $cart_prices_name
	 * @return bool|null
	 */
	public function plgVmOnSelectedCalculatePriceShipment (VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name) {

		return $this->onSelectedCalculatePrice ($cart, $cart_prices, $cart_prices_name);
	}

	/**
	 * plgVmOnCheckAutomaticSelected
	 * Проверяет, сколько плагинов доступно. Если только один, у пользователя не будет выбора.
	 * Перейдите на страницу edit_xxx. Плагин должен сначала проверить, правильный ли это тип.
	 *
	 * @param VirtueMartCart $cart Объект корзины
	 * @return NULL если плагин не найден, 0 если было найдено более одного плагина, virtuemart_xxx_id если найден только один плагин
	 *
	 */
	function plgVmOnCheckAutomaticSelectedShipment (VirtueMartCart $cart, array $cart_prices, &$shipCounter) {
		return $this->onCheckAutomaticSelected ($cart, $cart_prices, $shipCounter);
	}
	
	/**
	 * Последняя проверка перед подтверждением заказа.
	 *
	 * @param VirtueMartCart $cart Объект корзины
	 *
	 */
	function plgVmOnCheckoutCheckDataShipment(VirtueMartCart $cart){

		if(empty($cart->virtuemart_shipmentmethod_id)) return false;

		if ($this->getPluginMethods($cart->vendorId) === 0) {
			return NULL;
		}

		foreach ($this->methods as $this->_currentMethod) {
			if($cart->virtuemart_shipmentmethod_id == $this->_currentMethod->virtuemart_shipmentmethod_id){
				if(!$this->checkConditions($cart,$this->_currentMethod,$cart->cartPrices)){
					return false;
				}
				break;
			}
		}
	}

	/**
	 * This method is fired when showing when priting an Order
	 * В нем отображаются данные, относящиеся к конкретному способу оплаты.
	 *
	 * @param integer $_virtuemart_order_id The order ID
	 * @param integer $method_id  method used for this order
	 * @return mixed Null when for payment methods that were not selected, text (HTML) otherwise
	 * @author Valerie Isaksen
	 */
	function plgVmOnShowOrderPrint ($order_number, $method_id) {
		return $this->onShowOrderPrint ($order_number, $method_id);
	}

	function plgVmDeclarePluginParamsShipmentVM3 (&$data) {
		return $this->declarePluginParams ('shipment', $data);
	}


	/**
	 * Используется после сохранения способа доставки для корректировки установленных настроек модуля на новые, а также их проверке.
	 * @param $data
	 * @param $table
	 * @return bool
	 */
	function plgVmSetOnTablePluginShipment(&$data,&$table){

		$name = $data['shipment_element'];
		$id = $data['shipment_jplugin_id'];

		if (!empty($this->_psType) and !$this->selectedThis ($this->_psType, $name, $id)) {
			return FALSE;
		} else {
			$tCon = array('lengthD','widthD','heightD','weightD','weight_start','weight_stop','volume_start','volume_stop','min_amount','max_amount','additional_cost_percent','additional_cost','free_shipment');
			foreach($tCon as $f){
				if(!empty($data[$f])){
					$data[$f] = str_replace(array(',',' '),array('.',''),$data[$f]);
				}
			}

			//Reasonable tests:
			if(!empty($data['weight_start']) and !empty($data['weight_stop']) and (float)$data['weight_start']>=(float)$data['weight_stop']){
				vmWarn('VMSHIPMENT_BAIKAL_WEIGHT_CONDITION_WRONG');
			}
			
			if(!empty($data['volume_start']) and !empty($data['volume_stop']) and (float)$data['volume_start']>=(float)$data['volume_stop']){
				vmWarn('VMSHIPMENT_BAIKAL_VOLUME_CONDITION_WRONG');
			}
			
			if(!empty($data['min_amount']) and !empty($data['max_amount']) and (float)$data['min_amount']>=(float)$data['max_amount']){
				vmWarn('VMSHIPMENT_BAIKAL_AMOUNT_CONDITION_WRONG');
			}


			//$data['show_on_pdetails'] = (int) $data['show_on_pdetails'];
			return $this->setOnTablePluginParams ($name, $id, $table);
		}
	}
	
	/**
	 * Поиск населенного пункта по части слова.
	 *
	 * called by vmuserfield
	 * @param $element
	 * @param $query
	 * @return array, bool
	 */
	public function plgVmOnAutocompleteCities($element, $query) {
		if (!$this->selectedThisElement($element)) {
			return FALSE;
		}
		
		$vendorId = 1;
		if ($this->getPluginMethods($vendorId) === 0) {
			return false;
		}

		foreach ($this->methods as $method) {
			if(!$method->published)
				continue;			
			$arCities = [];
			$apiKey = $method->test ? $method->authKeyTest : $method->authKey;
			$response = [];
			$response = $this->baikalsrTools::getCitiesByName($query, "", $apiKey, $method->test);
			if (!empty($response) && is_array($response))
				foreach($response as $item){
					$arCities[] = array(
						"id"=>$item["guid"],
						"label"=>!empty($item['parents']) ? $item['title'] . ' (' . $item['parents'] . ')' : $item['title'], 
						"value"=>$item['title']
					);
				}
			return $arCities;			
		}
		return false;
	}
	
	/**
	 * Этот метод вызывается при запросах (например, Ajax) к плагину из административной части сайта.
	 *
	 * @param string $type Тип плагина, например vmuserfield
	 * @param string $name Имя плагина
	 * @return $render mixed Null В качестве результата возвращает текст (HTML) или JSON.
	 */	
	function plgVmOnSelfCallBE($type, $name, &$render) {

		if($name != $this->_name || $type != 'vmshipment') {
			return FALSE;
		}

		$action = vRequest::getCmd('action');
		$virtuemart_shipmentmethod_id = vRequest::getInt('virtuemart_shipmentmethod_id');
		//Load the method
		if(!($this->_currentMethod = $this->getVmPluginMethod($virtuemart_shipmentmethod_id))) {
			return NULL; // Another method was selected, do nothing
		}

		switch ($action) {

			case 'popupShow':
				$virtuemart_order_id = vRequest::getInt('virtuemart_order_id');
				if(empty($virtuemart_order_id)){
					return NULL; 
				}
				$popup_data = $this->_getShippingPopupData($virtuemart_order_id, $virtuemart_shipmentmethod_id);
				$html = $this->renderByLayout('popup_shipping', $popup_data);
				echo $html;	
				exit;
			case 'getCities':	
				$json = [];		
				$query = vRequest::getString('term');	
				if(!empty($query)){
					$apiTypeTest = vRequest::getInt('apiTypeTest');
					$apiKey = vRequest::getString('apiKey');
					$response = $this->baikalsrTools::getCitiesByName($query, "", $apiKey, $apiTypeTest);
					if (!empty($response) && is_array($response))
						foreach($response as $item){
							$json[] = array(
								"id"=>$item["guid"],
								"label"=>!empty($item['parents']) ? $item['title'] . ' (' . $item['parents'] . ')' : $item['title'], 
								"value"=>$item['title']
							);
						}
				}
				echo json_encode($json);
				jExit();
				break;
			case 'getStreets':	
				$json = [];		
				$query = vRequest::getString('term');	
				$guid = vRequest::getString('localityGuid');
				if(!empty($guid) && !empty($query)){				
					$apiTypeTest = vRequest::getInt('apiTypeTest');
					$apiKey = vRequest::getString('apiKey');
					$response = $this->baikalsrTools::getStreetsByName($guid, $query, $apiKey, $apiTypeTest);
					if (!empty($response) && is_array($response))
						foreach($response as $item){
							$json[] = array(
								"id"=>$item["guid"],
								"label"=>!empty($item['parents']) ? $item['title'] . ' (' . $item['parents'] . ')' : $item['title'], 
								"value"=>$item['title']
							);
						}	
				}
				echo json_encode($json);
				jExit();
				break;
			case 'getHouses':	
				$json = [];		
				$query = vRequest::getString('term');	
				$guid = vRequest::getString('streetGuid');	
				if(!empty($guid) && !empty($query)){					
					$apiTypeTest = vRequest::getInt('apiTypeTest');
					$apiKey = vRequest::getString('apiKey');
					$response = $this->baikalsrTools::getHousesByName($guid, $query, $apiKey, $apiTypeTest);
					if (!empty($response) && is_array($response))
						foreach($response as $item){
							$json[] = array(
								"id"=>$item["houseguid"],
								"label"=>$item['formatted'],
								"buildnum"=>$item['buildnum'],
								"strucnum"=>$item['strucnum'],
								"value"=>$item['housenum']
							);
						}
				}
				echo json_encode($json);
				jExit();
				break;
			case 'getCargoTypes':	
				$json = array('elements' => []);			
				$apiTypeTest = vRequest::getInt('apiTypeTest');
				$apiKey = vRequest::getString('apiKey');
				$response = $this->baikalsrTools::getCargoTypes($apiKey, $apiTypeTest);
				if(isset($response['error']) && !empty($response['error'])){
					$json['error'] = $response['error'];
				}else{
					foreach($response as $data) {
						if(isset($data['id']) && isset($data['name']))
							$json['elements'][] = array('id' => $data['id'], 'name' => $data['name']);
					}
				}
				echo json_encode($json);
				jExit();
				break;
			case 'getContragents':	
				$json = array('elements' => []);			
				$apiTypeTest = vRequest::getInt('apiTypeTest');
				$apiKey = vRequest::getString('apiKey');
				$response = $this->baikalsrTools::getContragents($apiKey, $apiTypeTest);
				if(isset($response['error']) && !empty($response['error'])){
					$json['error'] = $response['error'];
				}else{
					foreach($response as $data) {
						if(isset($data['guid']) && isset($data['name']))
							$json['elements'][] = array('id' => $data['guid'], 'name' => $data['name']);
					}
				}
				echo json_encode($json);
				jExit();
				break;
			case 'getTerminals':	
				$json = array('elements' => []);
				$guid = vRequest::getString('localityGuid');
				if(!empty($guid)){
					$terminal_type = vRequest::getString('terminalType');						
					if(empty($terminal_type))
						$terminal_type = 'start';						
					$apiTypeTest = vRequest::getInt('apiTypeTest');
					$apiKey = vRequest::getString('apiKey');
					$response = $this->baikalsrTools::getAffiliateData($guid, $apiKey, $apiTypeTest);

					if(isset($response['error']) && !empty($response['error'])){
						$json['error'] = $response['error'];
					}else{
						if (isset($response["terminals"]) && !empty($response["terminals"])) {
							foreach($response["terminals"] as $terminal) {
								if(isset($terminal[$terminal_type]) && $terminal[$terminal_type]){
									$terminal["address"] = $this->baikalsrTools::htmlspecialcharsBack($terminal["address"]);
									$json['elements'][] = array('id' => $terminal['id'], 'name' => $terminal['name']." (".$terminal["address"].")");
								}
							}
						}
					}
				}
				echo json_encode($json);
				jExit();
				break;
			case 'submitOrderForm':
				$virtuemart_order_id = vRequest::getInt('virtuemart_order_id');
				if(empty($virtuemart_order_id)){
					return NULL; 
				}
				$json = array();
				if (isset($_POST['params']) && !empty($_POST['params'])){
					$popup_data = $this->_getShippingPopupData($virtuemart_order_id, $virtuemart_shipmentmethod_id, $_POST["params"]);
					$json['html'] = $this->renderByLayout('popup_shipping', $popup_data);
					if(isset($popup_data['success']) && $popup_data['success']){
						$json['toolbar'] = $this->renderByLayout( 
							'btn_toolbar', 
							array(
								"virtuemart_shipmentmethod_id" => $virtuemart_shipmentmethod_id, 
								"virtuemart_order_id" => $virtuemart_order_id,
								"shipment_id" => $popup_data['form_data']->shipment_id
							)
						);
					}				
				}else{
					$json['error'] = vmText::_('VMSHIPMENT_BAIKAL_ERROR_REQUEST');
				}	
				echo json_encode($json);
				jExit();
				break;
			case 'submitCalcForm':
				$json = array();
				if (isset($_POST['params']) && !empty($_POST['params'])){
					$config = $this->getVmPluginMethod ($virtuemart_shipmentmethod_id);
					if (isset($config->test) && isset($config->authKeyTest) && isset($config->authKey)){
						if($config->test){
							$this->baikalsrTools::defineAuthParams( $config->authKeyTest, true );
						}else{
							$this->baikalsrTools::defineAuthParams( $config->authKey, false );
						}				
					}
					$json = $this->baikalsrTools::calculate($_POST['params']);			
				}else{
					$json['error'] = vmText::_('VMSHIPMENT_BAIKAL_ERROR_REQUEST');
				}	
				echo json_encode($json);
				jExit();
				break;
			case 'tracking':
				$virtuemart_order_id = vRequest::getInt('virtuemart_order_id');
				if(empty($virtuemart_order_id)){
					return NULL; 
				}
				$json = array();
				//get shipment order by virtuemart_order_id
				$shipment = $this->_getShippingInfo($virtuemart_order_id);
				if (!count((array)$shipment)){
					$json['error'] = vmText::_('VMSHIPMENT_BAIKAL_ERROR_REQUEST');
				}else{
					$config = $this->getVmPluginMethod ($virtuemart_shipmentmethod_id);
					if (isset($config->test) && isset($config->authKeyTest) && isset($config->authKey)){
						if($config->test){
							$this->baikalsrTools::defineAuthParams( $config->authKeyTest, true );
						}else{
							$this->baikalsrTools::defineAuthParams( $config->authKey, false );
						}				
					}
					$baikalResponse = $this->baikalsrTools::getOrderData($shipment->shipment_id);
					if(isset($baikalResponse["status"]["name"]) && !empty($baikalResponse["status"]["name"])){
						$shipment->status_name = $baikalResponse["status"]["name"];
					}else{
						$json['error'] = vmText::_('VMSHIPMENT_BAIKAL_ERROR_API_NO_RESPONSE');
					}
					if (isset($baikalResponse["total"]["sum"]) && !empty($baikalResponse["total"]["sum"])) {
						$shipment->shipment_actual_cost = (float) $baikalResponse["total"]["sum"];
					}else{
						$json['error'] = vmText::_('VMSHIPMENT_BAIKAL_ERROR_API_NO_RESPONSE');
					}		
					$this->storePSPluginInternalData ((array)$shipment);	
					$json['html'] = $this->_getShippingInfoBody($shipment);					
				}		
				echo json_encode($json);
				jExit();
				break;
			default:
				//$this->baikalsrError(vmText::_('VMSHIPMENT_BAIKAL_ERROR_API_NO_RESPONSE'));
				return;
		}
	}
}

// No closing tag
