<?php
defined('_JEXEC') or die('Restricted access');

define('DS', DIRECTORY_SEPARATOR);

jimport ('joomla.filesystem.folder');

/**
 * Installation script for the plugin
 *
 */

class plgVmShipmentBaikalsrInstallerScript 
{
    /**
     * Constructor
     *
     * @param   JAdapterInstance  $adapter  The object responsible for running this script
     */
	public function __construct()
	{
		$this->minimum_php_release = JOOMLA_MINIMUM_PHP;
	}
	
    /**
     * Called before any type of action
     *
     * @param   string  $route  Which action is happening (install|uninstall|discover_install)
     * @param   JAdapterInstance  $adapter  The object responsible for running this script
     *
     * @return  boolean  True on success
     */
	public function preflight ($type, $parent) 
    {		
		$error = 0;
		
		$app = JFactory::getApplication ();

		if (version_compare (phpversion (), $this->minimum_php_release, '<')) 
		{
			$app->enqueueMessage ('Plugin requires PHP ' . $this->minimum_php_release . ' or later version!', 'error');
			$error = 1;
		}

		if (!file_exists (JPATH_SITE . '/components/com_virtuemart/virtuemart.php'))
		{
			$app->enqueueMessage ('Please install component \"virtuemart\"', 'error');
			$error = 1;
		}
		
		if (!function_exists('curl_init'))
		{
			$app->enqueueMessage ('cURL library is not loaded.', 'error');
			$error = 1;
		}
		
		if ($error) 
		{
			$app->enqueueMessage ('The installation was canceled', 'error');			
			return false;
		}

		return true;
	}
 
    /**
     * Called after any type of action
     *
     * @param   string  $route  Which action is happening (install|uninstall|discover_install)
     * @param   JAdapterInstance  $adapter  The object responsible for running this script
     *
     * @return  boolean  True on success
     */
    public function postflight($route, JAdapterInstance $adapter){

		$dst = JPATH_ROOT .'/images/virtuemart/shipment';
		if(!JFolder::exists($dst)){
			JFolder::create ($dst);
		}
		
		$src = dirname(__FILE__) .'/assets/images';
		$this->_recurse_copy($src,$dst);
		
		 // enabling plugin
		try
		{
			$db = JFactory::getDBO();
			$query = $db->getQuery(true);
			$query->update($db->qn('#__extensions'))
				->set($db->qn('enabled') . ' = 1')
				->where($db->qn('type') . ' = ' . $db->q('plugin'))
				->where($db->qn('element') . ' = ' . $db->q('baikalsr'));
			$db->setQuery($query)->execute();
		}
		catch (Exception $e)
		{
			// If that fails it's not the end of the world. The component is still usable, so just swallow any
			// exception.
		}
		
        return True;
	}
	
	/**
	 * copy all $src to $dst folder and remove it
	 *
	 * @param String $src path
	 * @param String $dst path
	 * @param String $type modulesBE, modules, plugins, languageBE, languageFE
	 */
	private function _recurse_copy ($src, $dst) {

		static $failed = false;
		$dir = opendir ($src);

		if (is_resource ($dir)) {
			while (FALSE !== ($file = readdir ($dir))) {
				if (($file != '.') && ($file != '..')) {
					if (is_dir ($src . DS . $file)) {
						if(!JFolder::create($dst . DS . $file)){
							$app = JFactory::getApplication ();
							$app->enqueueMessage ('Couldnt create folder ' . $dst . DS . $file);
						}
						$this->recurse_copy ($src . DS . $file, $dst . DS . $file);
					} else {
						if (JFile::exists ($dst . DS . $file)) {
							if (!JFile::delete ($dst . DS . $file)) {
								$app = JFactory::getApplication ();
								$app->enqueueMessage ('Couldnt delete ' . $dst . DS . $file);
								//return false;
							}
						}
						if (!JFile::move ($src . DS . $file, $dst . DS . $file)) {
							$app = JFactory::getApplication ();
							$app->enqueueMessage ('Couldnt move ' . $src . DS . $file . ' to ' . $dst . DS . $file);
							$failed = true;
							//return false;
						}
					}
				}
			}
			closedir ($dir);
			if (is_dir ($src) and !$failed) {
				JFolder::delete ($src);
			}
		} else {
			$app = JFactory::getApplication ();
			$app->enqueueMessage ('Baikalsr Installer recurse_copy; Couldnt read source directory '.$dir);
			return false;
		}
		return true;
	}
}