<?php
defined('_JEXEC') or die();

class JFormFieldBsautocomplete extends JFormField
{
	var $type = 'Bsautocomplete';

	protected function getInput()
	{
		$attr = '';

		// Initialize some field attributes.
		$attr .= !empty($this->class) ? ' class="' . $this->class . '"' : '';
		$attr .= $this->disabled ? ' disabled' : '';
		$attr .= $this->size ? ' size="' . $this->size . '"' : '';
		$attr .= $this->multiple ? ' multiple' : '';
		$attr .= $this->required ? ' required aria-required="true"' : '';
		$attr .= $this->autofocus ? ' autofocus' : '';
		$attr .= strlen($this->getAttribute("hint")) ? 'placeholder="' . vmText::_(htmlspecialchars($this->getAttribute("hint"), ENT_COMPAT, 'UTF-8')) . '"' : '';
		$attr .= $this->getAttribute("target") ? ' data-url="' . $this->getAttribute("target") . '"' : '';
		$attr .= $this->getAttribute("chars") ? ' data-chars="' . $this->getAttribute("chars") . '"' : '';
		
		// Initialize JavaScript field attributes.
		$attr .= !empty($this->onchange) ? ' onchange="' . $this->onchange . '"' : '';
		$attr .= !empty($this->onclick) ? ' onclick="' . $this->onclick . '"' : '';
		
		foreach ($this->form->getFieldset() as $field) {
			if ($field->id == $this->id . '_guid')
				$html = $field->renderField();
		}
		
		$html .= '<input id="' . $this->id . '" name="' . $this->name . '" type="text" data-title="' . $this->value . '" value="' . $this->value . '" '. $attr .'>';

		return $html;
	}
}
