<?php
defined('_JEXEC') or die();

if (!class_exists ('Baikalsr\Lib\Tools')) {
	require(VMPATH_PLUGINS . DS . 'vmshipment' . DS . 'baikalsr' . DS . 'lib' . DS . 'tools.php');
}

class JFormFieldBslist extends JFormField
{

    var $type = 'Bslist';
	
	protected function _getLegalForm()
    {
		return 1;
	}
	
    protected function getInput()
    {
        $options = [];

		$attr = '';

		// Initialize some field attributes.
		$attr .= !empty($this->class) ? ' class="' . $this->class . '"' : '';
		$attr .= $this->disabled ? ' disabled' : '';
		$attr .= $this->multiple ? ' multiple' : '';
		$attr .= $this->required ? ' required aria-required="true"' : '';
		$attr .= $this->autofocus ? ' autofocus' : '';
		$attr .= $this->getAttribute("target") ? ' data-url="' . $this->getAttribute("target") . '"' : '';
		
		// Initialize JavaScript field attributes.
		$attr .= !empty($this->onchange) ? ' onchange="' . $this->onchange . '"' : '';
		$attr .= !empty($this->onclick) ? ' onclick="' . $this->onclick . '"' : '';
		
		$shipmentmethod_id = 0;
		
		$baikalsrTools = new Baikalsr\Lib\Tools();
		
		$view = vRequest::getCmd('view');
		if( $view == "plugin" ){
			$shipmentmethod_id = vRequest::getInt('virtuemart_shipmentmethod_id');
		}elseif( $view == "shipmentmethod"){
			$cid = vRequest::getInt('cid');
			if(isset($cid[0]) && !empty($cid[0])){
				$shipmentmethod_id = $cid[0];
			}
		}
		
		if(!empty($shipmentmethod_id)){
			$config = VmModel::getModel('shipmentmethod')->getShipment($shipmentmethod_id);
			if (isset($config->test) && isset($config->authKeyTest) && isset($config->authKey)){
				if($config->test){
					$baikalsrTools::defineAuthParams( $config->authKeyTest, true );
				}else{
					$baikalsrTools::defineAuthParams( $config->authKey, false );
				}
			}
		}
		
		$action = $this->getAttribute("target");
		switch ($action) {
			case 'getContragents':
				$response = $baikalsrTools::getContragents();
				if(isset($response) && !empty($response)){
					foreach ($response as $data){
						if(isset($data["name"]) && !empty($data["name"])
							&&	isset($data["guid"]) && !empty($data["guid"]))
							$options[] = JHTML::_('select.option', $data['guid'] , $data['name']);
					}
				}	
				break;
			case 'getOpf':
				$response = $baikalsrTools::_getPartnerTypes();	
				if(!empty($response)){
					foreach ($response as $data){
						if(isset($data["legalForm"]) && $data["legalForm"] == 1)
							if(isset($data["name"]) && !empty($data["name"])
								&&	isset($data["id"]) && !empty($data["id"]))
							$options[$data['id']] = JHTML::_('select.option', $data['id'] , $data['name']);
					}
				}
				break;
			case 'getDocuments':
				$response = $baikalsrTools::_getPartnerTypes();	
				if(!empty($response)){
					foreach ($response as $data){
						if(isset($data["legalForm"]) && $data["legalForm"] == 2)
							if(isset($data["name"]) && !empty($data["name"])
								&&	isset($data["id"]) && !empty($data["id"]))
								$options[$data['id']] = JHTML::_('select.option', $data['id'] , $data['name']);
					}
				}
				break;
			case 'getTerminals':
				$guid = $this->form->getValue("departure_guid", "params");
				$terminal_type = "start";
				if($this->fieldname == "destination_terminal_id"){					
					$guid = $this->form->getValue("destination_guid", "params");
					$terminal_type = "finish";
				}
				$response = $baikalsrTools::_getAffiliateData($guid);
				if (isset($response["terminals"]) && !empty($response["terminals"])) {
					foreach($response["terminals"] as $data) {
						if (isset($data[$terminal_type]) && $data[$terminal_type]){ 
							if(!isset($data['id']) || empty($data['id']))
								$data['id'] = 0;
							if(isset($data['name']) && !empty($data['name']))
								$options[] = JHTML::_('select.option', $data['id'] , $data['name']." (".$baikalsrTools::htmlspecialcharsBack($data["address"]).")");
						}
					}
				}
				break;
			case 'getPacking':
				$options[] = JHTML::_('select.option', 0 , vmText::_('VMSHIPMENT_BAIKAL_NO_PACKAGE'));				
				$options[] = JHTML::_('select.option', 19 , vmText::_('VMSHIPMENT_BAIKAL_PACKING_1'));
				$options[] = JHTML::_('select.option', 21 , vmText::_('VMSHIPMENT_BAIKAL_PACKING_2'));
				$options[] = JHTML::_('select.option', 22 , vmText::_('VMSHIPMENT_BAIKAL_PACKING_3'));
				$options[] = JHTML::_('select.option', 23 , vmText::_('VMSHIPMENT_BAIKAL_PACKING_4'));
				$options[] = JHTML::_('select.option', 24 , vmText::_('VMSHIPMENT_BAIKAL_PACKING_5'));
				$options[] = JHTML::_('select.option', 2770 , vmText::_('VMSHIPMENT_BAIKAL_PACKING_6'));
				$options[] = JHTML::_('select.option', 2797 , vmText::_('VMSHIPMENT_BAIKAL_PACKING_7'));
				$options[] = JHTML::_('select.option', 2820 , vmText::_('VMSHIPMENT_BAIKAL_PACKING_8'));
				$options[] = JHTML::_('select.option', 3228 , vmText::_('VMSHIPMENT_BAIKAL_PACKING_9'));
				break;
			case 'getCargoTypes':
				$response = $baikalsrTools::_getCargoTypes();
				if(isset($response) && !empty($response)){
					foreach ($response as $data){
						$options[] = JHTML::_('select.option', $data['id'] , $data['name']);
					}
				}
				break;
		}
		
		if(empty($options)){
			$options[] = JHTML::_('select.option', '', vmText::_('VMSHIPMENT_BAIKAL_NO_DATA'));
		}

		$html = '<select id="' . $this->id . '" name="' . $this->name . '" '. $attr .'>';
        $html .= JHTMLSelect::Options( $options, 'value', 'text', $this->value, false );
        $html .= '</select>';
        return $html;
    }
}
