<?php

defined('JPATH_BASE') or die();

jimport('joomla.form.formfield');
class JFormFieldGetBaikalsr extends JFormField
{
	/**
	 * Element name
	 *
	 * @access    protected
	 * @var        string
	 */
	var $type = 'getBaikalsr';

	protected function getInput()
	{
		$shipmentMethodId = vRequest::getInt('cid');
		
		$doc = JFactory::getDocument();
		vmJsApi::css('baikalsr', 'plugins/vmshipment/baikalsr/assets/css/');
		$doc->addScriptDeclaration('var vmShipmentMethodId = "&virtuemart_shipmentmethod_id=' . (isset($shipmentMethodId[0]) ? $shipmentMethodId[0] : 0) . '";'); 
		$doc->addScriptDeclaration('var translate = {
			no_data: "' . vmText::_( 'VMSHIPMENT_BAIKAL_NO_DATA') . '",
			send_request: "' . vmText::_('VMSHIPMENT_BAIKAL_SEND_REQUEST') . '",
			entry_fio: "' . vmText::_( 'VMSHIPMENT_BAIKAL_FIO') . '",
			entry_inn_kpp: "' . vmText::_( 'VMSHIPMENT_BAIKAL_INN_KPP') . '",
			entry_inn: "' . vmText::_( 'VMSHIPMENT_BAIKAL_INN') . '",
			err_title: "' . vmText::_( 'VMSHIPMENT_BAIKAL_ERROR') . '",
			entry_contact_person: "' . vmText::_( 'VMSHIPMENT_BAIKAL_CONTACT_PERSON') . '",
		};');

		vmJsApi::addJScript('baikalsr', '/plugins/vmshipment/baikalsr/assets/js/baikalsr.js');
		$baikalsr_init = "	
			jQuery().ready(function ($) {
				window.baikalsr.getApiParams = function () {
					if ($(window.baikalsr.api.test_mode).length > 0) {
						var apiKey = $(window.baikalsr.api.test_mode + ' input[type=radio]:checked').val() == 1 ? $(window.baikalsr.api.authkeytest).val() : $(window.baikalsr.api.authkey).val();
						if(typeof(apiKey) != 'undefined' && !apiKey.length>0)
							apiKey = 'no_set';
						return {
							'apiKey': encodeURIComponent(apiKey),
							'apiTypeTest': encodeURIComponent($(window.baikalsr.api.test_mode + ' input[type=radio]:checked').val())
						}
					}else{
						return {}
					}
				};
				$(document).ready(function ($) {
					window.baikalsr.changeAdressVisibility(window.baikalsr.departure);
					window.baikalsr.changeFloorVisibility(window.baikalsr.departure.prr);
					window.baikalsr.MultiAutocompleteInit();
					window.baikalsr.AutocompleteInit();
				});
			});
			";
		vmJsApi::addJScript('baikalsr_init',$baikalsr_init);
		
		$logoBaikalsrUrl = 'https://www.baikalsr.ru/local/templates/main/i/logo_2024.svg';
		$logoBaikalsrUrl = '<img alt="baikalsr logo" src="' . $logoBaikalsrUrl . '" class="baikalsr-logo" width="300px" />';

		$html = '<div class="baikalsr-content-wrapper">
					<div class="baikalsr-content baikalsr-content-img">
					' . $logoBaikalsrUrl . '
					</div>
					<div class="baikalsr-content baikalsr-content-text">
						<div class="baikalsr-title-container"><span class="baikalsr-title">Общие сведения</span></div>
						<p>Модуль обеспечивает интеграцию Интернет-магазина со службой доставки "Байкал Сервис".</p>
						<p>Для работы модуля необходимо указать ключ API, который можно получить пройдя регистрацию в личном кабинете "Байкал Сервис". Все основные настройки по работе с заявками первоначально также выполняются в личном кабинете.</p>										
						<br>
						<div class="baikalsr-footer-btn">
							<a href="https://www.baikalsr.ru/tools/lk/" target="_blank" class="baikalsr-btn-signup">
								Личный кабинет
							</a>
						</div>
					</div>
				</div>';

		return $html;
	}
}
