<?php
defined('_JEXEC') or die();
use Joomla\CMS\Form\Form;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;
	
// Access check.
if (!JFactory::getUser()->authorise('core.admin'))
{
	throw new JAccessExceptionNotallowed(JText::_('JERROR_ALERTNOAUTHOR'), 403);
}
// base form definition
$form = Form::getInstance("popup_shipping", realpath(__DIR__ . '/..') . '/popup_shipping.xml');//, array("control" => "params", "load_data" => true));
$form->bind(array("params"=>$viewData['form_data']));
//Установим запрет на редактирование если данные отправлены по api
if(isset($viewData['disabled'])){
	foreach ($form->getFieldset() as $field) {
		$form->setFieldAttribute($field->fieldname, "disabled", true, "params");
	}
}elseif(isset($viewData['warning']) && count((array)$viewData['warning']) > 0){
	foreach($viewData['warning'] as $key=>$warning){
		$attrClass = $form->getFieldAttribute($key, "class", null, "params");
		$form->setFieldAttribute($key, "class", trim($attrClass . " invalid"), "params");
	}
}
?>
<div id="popup-shipping-container" class="virtuemart-admin-area">
	<input type="hidden" id="params_authKey" value="<?=$viewData['form_data']->authKey?>"/>
	<input type="hidden" id="params_authKeyTest" value="<?=$viewData['form_data']->authKeyTest?>"/>	
	<input type="hidden" id="params_test" value="<?=$viewData['form_data']->test_mode?>"/>	
	<form action="<?= JRoute::_('index.php'); ?>" method="post" name="formPopupShipping" id="formPopupShipping" class="form-vertical form-popup-shipping">
		<?php if(!isset($viewData['disabled'])):?>
			<h2><?php echo vmText::_('VMSHIPMENT_BAIKAL_POPUP_TITLE'). ' ' . $viewData['form_data']->virtuemart_order_id; ?></h2>
			<div class="alert alert-info">
				<?=vmText::_( 'VMSHIPMENT_BAIKAL_INFO_POPUP_SHIPPING' ); ?>
			</div>
		<?php else:?>
			<h2><?php echo vmText::_('VMSHIPMENT_BAIKAL_POPUP_TITLE2'). ' ' . $viewData['form_data']->shipment_id; ?></h2>
			<div class="alert alert-info">
				<?=vmText::_( 'VMSHIPMENT_BAIKAL_POPUP_SUCCESS_BODY'). ' '. vmText::_( 'VMSHIPMENT_BAIKAL_TRACKING_NUMBER') . ': ' . $viewData['form_data']->tracking_number; ?> 
			</div>		
		<?php endif;?>
		<div id="popup-message-container">
			<?php if (isset($viewData['warning']) && count((array)$viewData['warning']) > 0):?>
			<div class="alert alert-danger alert-dismissible" role="alert">
				<button type="button" class="close" data-dismiss="alert">&times;</button>
				<h4 class="alert-heading"><i class="fa fa-exclamation-triangle" aria-hidden="true"></i>&nbsp;<?= vmText::_('WARNING'); ?></h4>
				<div class="alert-message">
					<?=vmText::_('VMSHIPMENT_BAIKAL_ERROR_WARNING');?>:
					<ul>
					<?php foreach($viewData['warning'] as $warning){
						echo '<li>'.$warning.'</li>';
					}?>
					</ul>
				</div>
			</div>
			<?php endif; ?>
			<?php 
			if (isset($viewData['errors']) && count((array)$viewData['errors']) != 0): ?>
			<div class="alert alert-danger alert-dismissible" role="alert">
				<button type="button" class="close" data-dismiss="alert">&times;</button>
				<h4 class="alert-heading"><i class="fa fa-exclamation-triangle" aria-hidden="true"></i>&nbsp;<?= vmText::_('ERROR'); ?></h4>
				<div class="alert-message">
					<?=vmText::_('VMSHIPMENT_BAIKAL_ERROR_API');?>:
					<ul>
					<?php foreach($viewData['errors'] as $error){
						echo '<li>'.$error.'</li>';
					}?>
					</ul>
				</div>
			</div>
			<?php endif; ?>
		</div>
		<fieldset class="adminform control-field">
			<legend><?php echo vmText::_ ('VMSHIPMENT_BAIKAL_CONSIGNOR_GROUP') ?></legend>
			<div class="row-fluid">
				<div class="span12"><?php //echo $form->renderFieldset('consignor_group');  ?>					
					<?php echo $form->renderField('consignor_contragent_id', 'params');?>
				</div>
			</div>
			<div class="row-fluid">
				<div class="span4">
					<?php echo $form->renderField('author_lastname', 'params');?>
					<?php echo $form->renderField('author_firstname', 'params');?>
					<?php echo $form->renderField('author_middlename', 'params');?>
					<?php echo $form->renderField('consignor_fio', 'params');?>
				</div>
				<div class="span4">
					<?php echo $form->renderField('consignor_phone', 'params');?>
				</div>
				<div class="span4">
					<?php echo $form->renderField('consignor_email', 'params');?>
				</div>
			</div>
		</fieldset>
		<fieldset class="adminform control-field">
			<legend><?php echo vmText::_ ('VMSHIPMENT_BAIKAL_CONSIGNEE_GROUP') ?></legend>
			<div class="row-fluid">
				<div class="span12">
					<?= $form->renderField('consignee_physical_person', 'params');?>
				</div>
			</div>
			<div class="row-fluid">
				<div class="span4">
					<?= $form->renderField('consignee_fio', 'params');?>
				</div>
				<div class="span4" style="<?= $viewData['form_data']->consignee_physical_person ? 'display:none;' : '';?>">
					<?= $form->renderField('consignee_legal_opf_id', 'params');?>
				</div>
				<div class="span4" style="<?= !$viewData['form_data']->consignee_physical_person ? 'display:none;' : '';?>">
					<?= $form->renderField('consignee_physical_document_id', 'params');?>
				</div>
				<div class="span4" style="<?= $viewData['form_data']->consignee_physical_person ? 'display:none;' : '';?>">
					<?php 
					echo $form->renderField('consignee_inn', 'params');
					echo $form->renderField('consignee_kpp', 'params');
					echo $form->renderField('consignee_inn_kpp', 'params'); ?>
				</div>
				<div class="span4" style="<?= !$viewData['form_data']->consignee_physical_person ? 'display:none;' : '';?>">
					<?php 
					echo $form->renderField('consignee_seria', 'params');
					echo $form->renderField('consignee_number', 'params');
					echo $form->renderField('consignee_seria_number', 'params'); ?>
				</div>
			</div>	
			<div class="row-fluid">
				<div class="span4">
					<?= $form->renderField('consignee_phone', 'params');?>
				</div>
				<div class="span4">
						<?= $form->renderField('consignee_email', 'params');?>
				</div>
				<div class="span4">
					<div style="<?= $viewData['form_data']->consignee_physical_person ? 'display:none;' : '';?>">
						<?= $form->renderField('consignee_company', 'params');?>
					</div>
					<div style="<?= !$viewData['form_data']->consignee_physical_person ? 'display:none;' : '';?>">
						<?= $form->renderField('consignee_no_document', 'params');?>
					</div>
				</div>
			</div>	
		</fieldset>
		<fieldset class="adminform control-field">
			<legend><?php echo vmText::_ ('VMSHIPMENT_BAIKAL_DEPARTURE_GROUP') ?></legend>
			<div class="row-fluid">
				<div class="span8">
					<?= $form->renderField('departure', 'params');?>
				</div>
				<div class="span4">
					<?= $form->renderField('departure_date', 'params');?>
				</div>
			</div>	
			<div class="row-fluid">
				<div class="span12">
					<?= $form->renderField('departure_from_address', 'params');?>
				</div>
			</div>	
			<div class="row-fluid">
				<div class="span12" style="<?= $viewData['form_data']->departure_from_address ? 'display:none;' : '';?>">
					<?= $form->renderField('departure_terminal_id', 'params');?>
				</div>
			</div>
			<div class="row-fluid">
				<div class="span12" style="<?= !$viewData['form_data']->departure_from_address ? 'display:none;' : '';?>">
					<?= $form->renderField('departure_street', 'params');?>
				</div>
			</div>
			<div class="row-fluid">
				<div class="span3" style="<?= !$viewData['form_data']->departure_from_address ? 'display:none;' : '';?>">
					<?= $form->renderField('departure_house', 'params');?>
				</div>
				<div class="span3" style="<?= !$viewData['form_data']->departure_from_address ? 'display:none;' : '';?>">
					<?= $form->renderField('departure_housing', 'params');?>
				</div>
				<div class="span3" style="<?= !$viewData['form_data']->departure_from_address ? 'display:none;' : '';?>">
					<?= $form->renderField('departure_building', 'params');?>
				</div>
				<div class="span3" style="<?= !$viewData['form_data']->departure_from_address ? 'display:none;' : '';?>">
					<?= $form->renderField('departure_apartment', 'params');?>
				</div>
			</div>
			<div class="row-fluid">
				<div class="span12">
					<?= $form->renderField('departure_comment', 'params');?>
				</div>
			</div>
		</fieldset>
		<fieldset class="adminform control-field">
			<legend><?php echo vmText::_ ('VMSHIPMENT_BAIKAL_PRR_GROUP') ?></legend>
			<div class="row-fluid">
				<div class="span3">
					<?php echo $form->renderField('departure_prr', 'params');?>
				</div>
				<div class="span3" style="<?= !$viewData['form_data']->departure_prr ? 'display:none;' : '';?>">
					<?php echo $form->renderField('departure_floor', 'params');?>
				</div>
				<div class="span3" style="<?= !$viewData['form_data']->departure_prr ? 'display:none;' : '';?>">
					<?php echo $form->renderField('departure_lift', 'params');?>
				</div>
			</div>
		</fieldset>
		<fieldset class="adminform control-field">
			<legend><?php echo vmText::_ ('VMSHIPMENT_BAIKAL_DESTINATION_GROUP') ?></legend>
			<div class="row-fluid">
				<div class="span8">
					<?= $form->renderField('destination', 'params');?>
				</div>
				<div class="span4">
					<?= $form->renderField('destination_date', 'params');?>
				</div>
			</div>	
			<div class="row-fluid">
				<div class="span12">
					<?= $form->renderField('destination_to_address', 'params');?>
				</div>
			</div>	
			<div class="row-fluid">
				<div class="span12" style="<?= $viewData['form_data']->destination_to_address ? 'display:none;' : '';?>">
					<?= $form->renderField('destination_terminal_id', 'params');?>
				</div>
			</div>
			<div class="row-fluid">
				<div class="span12" style="<?= !$viewData['form_data']->destination_to_address ? 'display:none;' : '';?>">
					<?= $form->renderField('destination_street', 'params');?>
				</div>
			</div>
			<div class="row-fluid">
				<div class="span3" style="<?= !$viewData['form_data']->destination_to_address ? 'display:none;' : '';?>">
					<?= $form->renderField('destination_house', 'params');?>
				</div>
				<div class="span3" style="<?= !$viewData['form_data']->destination_to_address ? 'display:none;' : '';?>">
					<?= $form->renderField('destination_housing', 'params');?>
				</div>
				<div class="span3" style="<?= !$viewData['form_data']->destination_to_address ? 'display:none;' : '';?>">
					<?= $form->renderField('destination_building', 'params');?>
				</div>
				<div class="span3" style="<?= !$viewData['form_data']->destination_to_address ? 'display:none;' : '';?>">
					<?= $form->renderField('destination_apartment', 'params');?>
				</div>
			</div>
			<div class="row-fluid">
				<div class="span12">
					<?= $form->renderField('destination_comment', 'params');?>
				</div>
			</div>
		</fieldset>
		<fieldset class="adminform control-field">
			<legend><?php echo vmText::_ ('VMSHIPMENT_BAIKAL_PRR_GROUP') ?></legend>
			<div class="row-fluid">
				<div class="span3">
					<?php echo $form->renderField('destination_prr', 'params');?>
				</div>
				<div class="span3" style="<?= !$viewData['form_data']->destination_prr ? 'display:none;' : '';?>">
					<?php echo $form->renderField('destination_floor', 'params');?>
				</div>
				<div class="span3" style="<?= !$viewData['form_data']->destination_prr ? 'display:none;' : '';?>">
					<?php echo $form->renderField('destination_lift', 'params');?>
				</div>
			</div>
		</fieldset>
		<fieldset class="adminform control-field" id="cargo_fieldset">
			<legend><?php echo vmText::_ ('VMSHIPMENT_BAIKAL_CARGO_GROUP') ?></legend>
			<div class="row-fluid">
				<div class="span6">
					<?php echo $form->renderField('cargotype_id', 'params');?>
				</div>
				<div class="span6">
					<?php echo $form->renderField('packing_id', 'params');?>
				</div>
			</div>
			<div class="row-fluid">	
				<div class="span4">
					<?php echo $form->renderField('length', 'params');?>
				</div>
				<div class="span4">
					<?php echo $form->renderField('width', 'params');?>
				</div>
				<div class="span4">
					<?php echo $form->renderField('height', 'params');?>
				</div>
			</div>	
			<div class="row-fluid">	
				<div class="span4">
					<?php echo $form->renderField('volume', 'params');?>
				</div>
				<div class="span4">
					<?php echo $form->renderField('weight', 'params');?>
				</div>
				<div class="span4">
					<?php echo $form->renderField('estimated_cost', 'params');?>
				</div>
			</div>			
		</fieldset>
		<input type="hidden" name="option" value="com_virtuemart"/>
		<input type="hidden" name="view" value="plugin"/>
		<input type="hidden" name="type" value="vmshipment"/>
		<input type="hidden" name="name" value="baikalsr"/>
		<input type="hidden" name="action" value="submitOrderForm"/>
		<input type="hidden" name="virtuemart_shipmentmethod_id" value="<?=$viewData['form_data']->virtuemart_shipmentmethod_id;?>"/>
		<input type="hidden" name="virtuemart_order_id" value="<?=$viewData['form_data']->virtuemart_order_id;?>"/>
		<div class="row-fluid">	
			<div class="span12">
				<span id="calcResult"></span>
			</div>
		</div>	
		<?php if(!isset($viewData['disabled'])):?>
			<div class="btn-toolbar">
				<button type="button" class="btn btn-success" onclick="return window.baikalsr.submitOrderForm(this);">
					<span class="icon-checkmark" aria-hidden="true"></span>
					<?php echo vmText::_('VMSHIPMENT_BAIKAL_SEND_REQUEST'); ?>
				</button>
			</div>
		<?php endif;?>
	</form>
</div>
<script type="text/javascript">
jQuery().ready(function ($) {
	window.baikalsr.getApiParams = function () {
		if ($(window.baikalsr.api.test_mode).length > 0) {
			var apiKey = $(window.baikalsr.api.test_mode).val() == 1 ? $(window.baikalsr.api.authkeytest).val() : $(window.baikalsr.api.authkey).val();
			if(typeof(apiKey) != 'undefined' && !apiKey.length>0)
				apiKey = 'no_set';
			return {
				'apiKey': encodeURIComponent(apiKey),
				'apiTypeTest': encodeURIComponent($(window.baikalsr.api.test_mode).val())
			}
		}else{
			return {}
		}
	};
	$(document)
		.on('change', '.form-control', function(e) {
			<?php if(!isset($viewData['disabled'])):?>
			window.baikalsr.submitCalcForm();
			<?php endif;?>
		});
    $(document).ready(function ($) {
		var container = '#popup-shipping-container';
		window.baikalsr.radiobtnInit(container);
		window.baikalsr.changeAdressVisibility(window.baikalsr.departure);
		window.baikalsr.changeFloorVisibility(window.baikalsr.departure.prr);
		window.baikalsr.changeAdressVisibility(window.baikalsr.destination);
		window.baikalsr.changeFloorVisibility(window.baikalsr.destination.prr);
		<?php if(!isset($viewData['disabled'])):?>
		window.baikalsr.submitCalcForm();
		window.baikalsr.chosenInit(container);
		window.baikalsr.calendarInit(container);
		window.baikalsr.AutocompleteInit();
		<?php endif;?>
	});
});
</script>	
