<?php
defined('_JEXEC') or die();

if (!class_exists('vmUserfieldPlugin')) {
	require(VMPATH_PLUGINLIBS . DS . 'vmuserfieldtypeplugin.php');
}

define('USERFIELD_BAIKALSR', 1);

class plgVmUserfieldBaikalsr extends vmUserfieldPlugin {

	var $varsToPush = array();

	const BAIKALSR_FOLDERNAME = "baikalsr";

	function __construct(& $subject, $config) {

		parent::__construct($subject, $config);

		$this->_loggable = TRUE;
		$this->tableFields = array_keys($this->getTableSQLFields());
		$this->_tablepkey = 'id';
		$this->_tableId = 'id';
		$this->setConfigParameterable('params', $this->varsToPush);
		$this->_userFieldName = 'baikalsr_city';
	}
	
	/**
	 * Метод модели вызывается перед сохранением настроек поля и позволяет, например, 
	 * изменить данные перед сохранением в базу данных.
	 *
	 */	
	public function plgVmOnBeforeUserfieldSave($plgName, &$data, &$field){
		$data['title'] = vmText::_('VMUSERFIELD_BAIKAL_CITY_CODE') . ' ' . '(GUID)';
		$data['name'] = $this->_userFieldName;
		$data['vNames'] = array();
		$data['vValues'] = array();
	}
	
	/**
	 * Метод модели вызывается перед открытием настроек поля для загрузки параметров плагина 
	 * В нем можно переопределить какой либо параметр поля, например, заголовок.
	 *
	 */
	function plgVmDeclarePluginParamsUserfieldVM3(&$data)
    {
		//$data->title = 'New title';
        return $this->declarePluginParams('userfield', $data);
    }
	
	/**
	 * Поля таблицы служащей для хранения информации по отправленным заявкам в ТК "Байкал-сервис" 
	 * @return array
	 */	
	function getTableSQLFields() {

		$SQLfields = array(
			'id' => 'int(11) UNSIGNED NOT NULL AUTO_INCREMENT',
			'virtuemart_user_id' => 'int(1) UNSIGNED',
			'terminal_id' => 'int(11)',
		);
		return $SQLfields;
	}
	
	/**
	 * Создает таблицу для плагина, структура которой определена методом getTableSQLFields().
	 * Или обновляет таблицу, если она существует.
	 * Вызывается при создании или обновлении способа доставки.
	 *
	 */
	function plgVmOnStoreInstallPluginTable($type, $data) {
		$fieldType = $data['type'];
		if ('plugin' . $this->_name != $fieldType) {
			return;
		}
		return $this->onStoreInstallPluginTable($type, $data['name']);
	}
	
	public function plgVmPrepareUserfieldDataSave($fieldType, $fieldName, $post, &$value, $params) {
		//nothing
	}

	/**
	 * @return array
	 */
	 
	protected function storePluginInternalData (&$values, $primaryKey = 0, $id = 0, $preload = FALSE) {
		//nothing
	}

	/**
	 * Этот метод вызывается при отображении пользовательского поля в публичной части сайта.
	 *
	 * @param string $_prefix Необязательный префикс для атрибута tagname формы
	 * @param mixed $field Структура содержащая реквизиты пользовательского поля
	 * @param integer $userId  Идентификатор пользователя
	 * @return $return mixed Null В качестве результата возвращает структура полей.
	 */

	public function plgVmOnUserfieldDisplay($_prefix, $field, $userId, &$return) {

		if ('plugin' . $this->_name != $field->type) {
			return;
		}
		$this->onShowUserDisplayUserfield($return['fields'][$field->name]);

		return '';

	}
	
	function onShowUserDisplayUserfield(&$form_field) {

		$view = vRequest::getString('view', '');
		if (($view == 'user')) {
			vmJsApi::addJScript('scriptbaikalsr', '/plugins/vmuserfield/baikalsr/assets/js/baikalsr.js');
			vmJsApi::css('baikalsr', 'plugins/vmuserfield/baikalsr/assets/css/');
			$form_field['hidden'] = true;
			$form_field['formcode'] = '<input type="hidden" id="'.$form_field['name'].'_field'.'" name="'.$form_field['name'].'" value="'.$form_field['value'].'">';
		} elseif ($view == 'orders') {
			$form_field['formcode'] = '<input type="text" id="'.$form_field['name'].'_field'.'" name="'.$form_field['name'].'" value="'.$form_field['value'].'" >';
		}else{
			//nothing
		}
	}
	
	/**
	 * Этот метод вызывается при запросах (например, Ajax) к плагину из публичной части сайта.
	 *
	 * @param string $type Тип плагина, например vmuserfield
	 * @param string $name Имя плагина
	 * @return $render mixed Null В качестве результата возвращает текст (HTML) или JSON.
	 */	
	function plgVmOnSelfCallFE($type, $name, &$render) {

		if($name != $this->_name || $type != 'vmuserfield') {
			return FALSE;
		}
		
		$action = vRequest::getCmd('action');
		switch ($action) {	
			case 'fias_cities':
				$query = vRequest::getString('term');
				JPluginHelper::importPlugin('vmshipment');
				$app = JFactory::getApplication();
				$return = $app->triggerEvent('plgVmOnAutocompleteCities', array('baikalsr', $query));
				$json = [];
				if(!$return[0])
					$json['error'] = vmText::_('VMSHIPMENT_BAIKAL_ERROR_API_NO_RESPONSE');
				else
					$json = $return[0];
				echo json_encode($json);
				jExit();
			break;
			default:
				//$this->baikalsrError(vmText::_('VMSHIPMENT_BAIKAL_ERROR_API_NO_RESPONSE'));
				return;	
		}

	}
}

// No closing tag
